package com.workflow.database.beans;

import java.util.Date;

import com.workflow.management.beans.ExampleHolder;

@SuppressWarnings("serial")
public class Sample extends Entity {
	private String sampleId;
	private String concentration;
	private String qualityValue;
	private Boolean isError;
	private Date insertedWhen;
	private Study study;

	public Sample() {
	}

	public String getSampleId() {
		return sampleId;
	}


	public void setSampleId(String sampleId) {
		this.sampleId = sampleId;
	}


	public String getConcentration() {
		if(concentration == null)
			return "";

		return concentration;
	}


	public void setConcentration(String concentration) {
		this.concentration = concentration;
	}


	public String getQualityValue() {
		if(qualityValue == null)
			return "";

		return qualityValue;
	}


	public void setQualityValue(String qualityValue) {
		this.qualityValue = qualityValue;
	}


	public Boolean getIsError() {
		return isError;
	}


	public void setIsError(Boolean isError) {
		this.isError = isError;
	}


	public Date getInsertedWhen() {
		return insertedWhen;
	}


	public void setInsertedWhen(Date insertedWhen) {
		this.insertedWhen = insertedWhen;
	}

	public Study getStudy() {
		return study;
	}

	public void setStudy(Study study) {
		this.study = study;
	}

	@Override
	public boolean equals(Object o) {
		if (o instanceof Sample) {
			Sample oSample = (Sample) o;
			return this.sampleId.trim().equalsIgnoreCase(oSample.getSampleId().trim());
		} 
		if (o instanceof ExampleHolder) {
			ExampleHolder exHolder = (ExampleHolder) o;
			return this.sampleId.trim().equalsIgnoreCase(exHolder.getSampleName().trim());
		}
		
		return false;
	}

	@Override
	public int hashCode() {
		return this.sampleId.trim().hashCode();
	}
}
