-- MySQL dump 10.13  Distrib 5.1.41, for Win32 (ia32)
--
-- Host: localhost    Database: snpflow
-- ------------------------------------------------------
-- Server version	5.1.41

--
-- Table structure for table `discordance`
--

DROP TABLE IF EXISTS `discordance`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `discordance` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `CALL_NAME` varchar(2) NOT NULL,
  `WELL` varchar(45) NOT NULL,
  `DISCORDANT` tinyint(1) NOT NULL,
  `SNP_FK` int(10) unsigned NOT NULL,
  `SAMPLE_ID` varchar(45) NOT NULL,
  `file_name` varchar(100) DEFAULT NULL,
  PRIMARY KEY (`ID`),
  KEY `FK_discordance_1` (`SNP_FK`),
  CONSTRAINT `FK_discordance_1` FOREIGN KEY (`SNP_FK`) REFERENCES `snp` (`ID`) on delete cascade
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `genotype`
--

DROP TABLE IF EXISTS `genotype`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `genotype` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `SAMPLE_ID` varchar(250) NOT NULL,
  `GENOTYPE` varchar(45) NOT NULL,
  `SNP_FK` int(10) unsigned NOT NULL,
  PRIMARY KEY (`ID`),
  KEY `FK_genotypes_1` (`SNP_FK`),
  CONSTRAINT `FK_genotypes_1` FOREIGN KEY (`SNP_FK`) REFERENCES `snp` (`ID`) on delete cascade
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `hapmap`
--

DROP TABLE IF EXISTS `hapmap`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `hapmap` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `POPULATION` varchar(45) NOT NULL,
  `HOMO1` double NOT NULL,
  `HOMO2` double NOT NULL,
  `HETERO` double NOT NULL,
  `TOTAL` int(10) unsigned NOT NULL,
  `CHI` double NOT NULL,
  `SNP_FK` int(10) unsigned NOT NULL,
  `HOMO_FREQ1` double NOT NULL,
  `HOMO_FREQ2` double NOT NULL,
  `HETERO_FREQ` double NOT NULL,
  PRIMARY KEY (`id`),
  KEY `FK_hapmap_1` (`SNP_FK`),
  CONSTRAINT `FK_hapmap_1` FOREIGN KEY (`SNP_FK`) REFERENCES `snp` (`ID`) on delete cascade
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `hwe`
--

DROP TABLE IF EXISTS `hwe`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `hwe` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `CHI_SQUARE` double NOT NULL,
  `EXACT` double NOT NULL,
  `HOMO_OBSERVED1` int(10) unsigned NOT NULL,
  `HOMO_OBSERVED2` int(10) unsigned NOT NULL,
  `HETERO_OBSERVED` int(10) unsigned NOT NULL,
  `HOMO_EXPECTED1` double NOT NULL,
  `HOMO_EXPECTED2` double NOT NULL,
  `HETERO_EXPECTED` double NOT NULL,
  PRIMARY KEY (`ID`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `link_user_permission`
--

DROP TABLE IF EXISTS `link_user_permission`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `link_user_permission` (
  `user_fk` int(10) unsigned NOT NULL,
  `permission_fk` int(10) unsigned NOT NULL,
  KEY `FK_link_user_permission_1` (`user_fk`),
  KEY `FK_link_user_permission_2` (`permission_fk`),
  CONSTRAINT `FK_link_user_permission_1` FOREIGN KEY (`user_fk`) REFERENCES `user` (`id`),
  CONSTRAINT `FK_link_user_permission_2` FOREIGN KEY (`permission_fk`) REFERENCES `permission` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `permission`
--

DROP TABLE IF EXISTS `permission`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `permission` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `key` varchar(100) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `sample`
--

DROP TABLE IF EXISTS `sample`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `sample` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `SAMPLE_ID` varchar(250) NOT NULL,
  `CONCENTRATION` varchar(250) DEFAULT NULL,
  `QUALITY_VALUE` varchar(250) DEFAULT NULL,
  `IS_ERROR` tinyint(1) NOT NULL,
  `INSERTED_WHEN` datetime NOT NULL,
  `STUDY_FK` int(10) unsigned NOT NULL,
  PRIMARY KEY (`ID`),
  UNIQUE KEY `UC_SAMPLE_ID` (`SAMPLE_ID`,`STUDY_FK`) USING BTREE,
  KEY `FK_sample_study` (`STUDY_FK`),
  CONSTRAINT `FK_sample_study` FOREIGN KEY (`STUDY_FK`) REFERENCES `study` (`ID`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `snp`
--

DROP TABLE IF EXISTS `snp`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `snp` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `NAME` varchar(250) NOT NULL,
  `CREATED_WHEN` datetime NOT NULL,
  `NUM_MULTIPLE` int(10) unsigned NOT NULL,
  `PROC_QC_SAMPLES` double NOT NULL,
  `PROC_CALL_RATE` double NOT NULL,
  `NUM_HOMO1` int(10) unsigned NOT NULL,
  `NAME_HOMO1` varchar(45) NOT NULL,
  `NUM_HOMO2` int(10) unsigned NOT NULL,
  `NAME_HOMO2` varchar(45) NOT NULL,
  `NUM_HETERO` int(10) unsigned NOT NULL,
  `NAME_HETERO` varchar(45) NOT NULL,
  `PROC_MAF` double NOT NULL,
  `HWE_FK` int(10) unsigned NOT NULL,
  `STUDY_FK` int(10) unsigned NOT NULL,
  `NUM_SAMPLES` int(10) unsigned NOT NULL,
  `PROC_DISC_RATE` double NOT NULL,
  `NUM_DISC` int(10) unsigned NOT NULL,
  `PROC_QC` double NOT NULL,
  `COMMENT` varchar(200) DEFAULT NULL,
  `INSERTED_BY` varchar(100) NOT NULL,
  `HAPMAP_FK` int(10) unsigned DEFAULT NULL,
  `HAPMAP_LOOKUP` varchar(100) DEFAULT NULL,
  `directory` varchar(100) DEFAULT NULL,
  PRIMARY KEY (`ID`),
  KEY `FK_snp_1` (`HWE_FK`),
  KEY `FK_snp_2` (`STUDY_FK`),
  KEY `FK_snp_3` (`HAPMAP_FK`),
  CONSTRAINT `FK_snp_1` FOREIGN KEY (`HWE_FK`) REFERENCES `hwe` (`ID`) on delete cascade,
  CONSTRAINT `FK_snp_2` FOREIGN KEY (`STUDY_FK`) REFERENCES `study` (`ID`) on delete cascade,
  CONSTRAINT `FK_snp_3` FOREIGN KEY (`HAPMAP_FK`) REFERENCES `hapmap` (`id`) on delete cascade
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `study`
--

DROP TABLE IF EXISTS `study`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `study` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `NAME` varchar(250) NOT NULL,
  `DESCRIPTION` varchar(250) DEFAULT NULL,
  `IDENTIFIER` varchar(45) NOT NULL,
  `NUM_MULTIPLE` int(10) unsigned NOT NULL,
  `ACTIVE` tinyint(1) NOT NULL,
  PRIMARY KEY (`ID`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `user`
--

DROP TABLE IF EXISTS `user`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `user` (
  `username` varchar(45) NOT NULL,
  `password` varchar(45) NOT NULL,
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `admin` int(1) DEFAULT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `UC_USERNAME` (`username`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=latin1;

insert into user (username, password, id, admin) values ('admin', 'AAF71CEC550B5F233AD8F07BB122A344', '1', '1');

-- Dump completed on 2012-02-29 10:00:58
