package com.workflow.filter;

import java.io.IOException;

import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;

import com.workflow.database.WorkflowDAO;

public class HibernateSessionFilter implements Filter {
	protected FilterConfig config;
	
	public void doFilter(final ServletRequest request, final ServletResponse response, final FilterChain chain) throws IOException, ServletException {
		try {
			chain.doFilter(request, response);	// nothing to do on incoming requests
			WorkflowDAO.commitTransaction();			// commit any open transactions
		} finally {
			WorkflowDAO.closeSession();					// close any sessions that are open
		}
	}
	
	public void init(final FilterConfig config) {
		this.config = config;
	}
	
	public void destroy() { }
}
