package com.workflow.filter;

import java.io.IOException;
import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import com.workflow.database.beans.User;

/**
 * Servlet Filter implementation class SessionFilter
 */
public class SessionFilter implements Filter {

    public SessionFilter() {
    }

	public void destroy() {
	}

	public void doFilter(ServletRequest request, ServletResponse response, FilterChain chain) throws IOException, ServletException {
		HttpServletRequest httpRequest = (HttpServletRequest) request;
		HttpSession session = httpRequest.getSession(false);
		HttpServletResponse httpResponse = (HttpServletResponse) response;

		if(session != null){
			User loggedInUser = (User) session.getAttribute("loggedInUser");

			if(loggedInUser == null && httpRequest.getRequestURI().endsWith("main.jsp")){
				httpResponse.sendRedirect("index.jsp");
			} else if(loggedInUser != null && httpRequest.getRequestURI().endsWith("index.jsp")){
				httpResponse.sendRedirect("main.jsp");
			} else{
				chain.doFilter(request, response);
			}
		} else if(httpRequest.getRequestURI().endsWith("main.jsp")){
			httpResponse.sendRedirect("index.jsp");
		}  else{
			chain.doFilter(request, response);
		}
	}

	public void init(FilterConfig fConfig) throws ServletException {}
}
