package com.workflow.management;

import java.util.List;

import javax.naming.AuthenticationException;

import org.apache.log4j.Logger;

import com.workflow.database.DatabaseUtils;
import com.workflow.database.beans.User;
import com.workflow.util.StringUtils;

public class AuthenticationManager {
	private static final Logger logger = Logger.getLogger(AuthenticationManager.class);
	
	public static User loginUser(String username, String password) throws AuthenticationException{
		User user = new User();
		user.setUsername(username.toLowerCase());
		user.setPassword(StringUtils.encodeMD5(password.toLowerCase()));
	
		logger.info("Trying to logging user with username::" + user.getUsername() + " and password::" + user.getPassword());
		List<User> list = DatabaseUtils.getList(User.class, user);

		User userFound;
		if(list.size() == 1){
			userFound = list.get(0);
		} else {
			logger.error("Found more or less than one user::"+list.size());
			throw new AuthenticationException("Given user is not allowed!!");
		}
		
		return userFound;
	}	
}