package com.workflow.management;

/**
 * Copyright (C) 2010-12 The Roslin Institute <contact andy.law@roslin.ed.ac.uk>
 *
 * This file is part of JEnsembl: a Java API to Ensembl data sources developed by the
 * Bioinformatics Group at The Roslin Institute, The Royal (Dick) School of
 * Veterinary Studies, University of Edinburgh.
 *
 * Project hosted at <http://jensembl.sourceforge.net/>.
 *
 * This is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License (version 3) as published by
 * the Free Software Foundation.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * in this software distribution. If not, see <http://www.gnu.org/licenses/gpl-3.0.html/>.
 */

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */


import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.Reader;
import java.io.StringReader;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Vector;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import javax.swing.text.MutableAttributeSet;
import javax.swing.text.html.HTML;
import javax.swing.text.html.HTMLEditorKit;
import javax.swing.text.html.parser.ParserDelegator;

import uk.ac.roslin.ensembl.config.DBConnection.DataSource;
import uk.ac.roslin.ensembl.config.EnsemblDBType;
import uk.ac.roslin.ensembl.dao.database.DBRegistry;
import uk.ac.roslin.ensembl.dao.database.DBSingleSpeciesCoreDatabase;
import uk.ac.roslin.ensembl.dao.database.DBSingleSpeciesVariationDatabase;
import uk.ac.roslin.ensembl.dao.database.DBSpecies;
import uk.ac.roslin.ensembl.dao.factory.DAOVariationFactory;
import uk.ac.roslin.ensembl.datasourceaware.core.DAChromosome;
import uk.ac.roslin.ensembl.datasourceaware.core.DADNASequence;
import uk.ac.roslin.ensembl.datasourceaware.variation.DAVariation;
import uk.ac.roslin.ensembl.model.Coordinate;
import uk.ac.roslin.ensembl.model.Mapping;
import uk.ac.roslin.ensembl.model.variation.Variation;

/**
 * 
 * @author tpaterso
 */
public class KGenomesManagement {
    
    /*getting variations mapped to a chromosome
    *looking at whether these are unique or not
    */
     public  static void main(String[] args) throws Exception {
    	 KGenomesManagement km = new KGenomesManagement(); 
    	 km.getSNP("rs1004402");
     }

	public  Vector<String> getSNP(String snp) throws MalformedURLException, IOException {
		long time = System.currentTimeMillis();
    	  URL url = new URL("http://www.ensembl.org/Homo_sapiens/Component/Variation/Web/PopulationGenotypes?db=core;v="+snp );
          InputStream is = url.openConnection().getInputStream();

          BufferedReader reader = new BufferedReader( new InputStreamReader( is )  );

          String line = null;
          String regExp = ".*<a href=\"(.*)\">.*";
          Pattern p = Pattern.compile( regExp, Pattern.CASE_INSENSITIVE );
      
          int i=0;
          StringBuffer sb = new StringBuffer();
          sb.append("<table>");

          while( ( line = reader.readLine() ) != null )  {
              Matcher m = p.matcher( line );  
              if( m.matches() && (i%2==1)) {
            	  String h =m.group(1);
            	  if (h.contains("EUR") || h.contains("AFR") || h.contains("AMR") || h.contains("ASN"))
            	    sb.append("<td>"+m.group(1));
              }
              i++;
          }
          reader.close();
     
     sb.append("</table>");
    	 
    	 
     Reader reader1 = new StringReader(sb.toString());
     
   //  Reader reader1 = new StringReader("<table><tr><td>Hello</td><td>World!</td></tr></table>");
        HTMLEditorKit.Parser parser = new ParserDelegator();
        HTMLTableParser htable = new HTMLTableParser();
        parser.parse(reader1, htable, true);
        reader.close();
        
         Vector<String> v1000G = new Vector<String>();
         v1000G=htable.getResult();
         
         System.out.println(System.currentTimeMillis()-time +  "  " );
        
         for ( int j =0; j < 64; j ++){
	        	if (j==0 || j%16==0){
	        		System.out.print("\n"+v1000G.get(j));
	        	}
	             else if (j%3==0)
	            	 System.out.print(" | " + v1000G.get(j));
	             else if (j%4==0)
		        	 System.out.print(" | " + v1000G.get(j));
	             else if (j%5==0)
		        	 System.out.print(" | " + v1000G.get(j));
	             else if (j%10==0)
		        	 System.out.print(" | " + v1000G.get(j));
	             else if (j%11==0)
		        	 System.out.print(" | " + v1000G.get(j));
	             else if (j%12==0)
		        	 System.out.print(" | " + v1000G.get(j));
	             else if (j%13==0)
		        	 System.out.print(" | " + v1000G.get(j));
	             else if (j%14==0)
		        	 System.out.print(" | " + v1000G.get(j));
	             else if (j%15==0)
		        	 System.out.print(" | " + v1000G.get(j));
         }
         System.out.println("---------");
         for ( int j =0; j < 64; j ++){
	        	if (j==0 ){
	        		System.out.print(v1000G.get(j).split(">")[1]);
	        	}
	        	else if (j%16==0){
	        		System.out.print("\n"+v1000G.get(j));
	        	}
	        	else
	        	 System.out.print(" | " + v1000G.get(j));
	         }
         
         
	return v1000G;
	}
     
     
     
     
     
} 




   
     


