package com.workflow.management;

import java.io.IOException;
import java.io.InputStream;
import java.net.URL;
import java.util.LinkedList;
import java.util.StringTokenizer;
import java.util.Vector;
import java.util.regex.Pattern;

import org.jsoup.Jsoup;
import org.jsoup.nodes.Document;
import org.jsoup.nodes.Element;
import org.jsoup.select.Elements;

import com.sun.org.apache.xerces.internal.impl.xs.identity.Selector.Matcher;

public class TableEg {
   public static void main(String[] args) {
      Vector<KGenomes> kg =get1000Genomes();
      
      for (int i = 0 ; i <kg.size(); i++){
    	  System.out.println(((KGenomes)kg.get(i)).getName() +" " +  kg.get(i).getHomo1() + " " + kg.get(i).getHetero() +" " +  kg.get(i).getHomo2() +" " +  kg.get(i).getCount() + " sum: " + kg.get(i).getSum() + " "+  kg.get(i).getHomo1Count() + " "+  kg.get(i).getHomo1Genotype()+ " " + kg.get(i).getHeteroCount() + " "+  kg.get(i).getHeteroGenotype()+" " +  kg.get(i).getHomo2Count()+ " "+  kg.get(i).getHomo2Genotype() );
      }
   }

   private static Vector<KGenomes> get1000Genomes() {
		Vector<KGenomes> kg = new Vector<KGenomes>();
		try {
	        
	         URL url = new URL("http://www.ensembl.org/Homo_sapiens/Component/Variation/Web/PopulationGenotypes?db=core;v=rs1729408" );
	         InputStream is = url.openConnection().getInputStream();

	         
	         Document doc = Jsoup.parse(is, "UTF-8", "http://www.ensembl.org");
	         Elements tableElements = doc.select("table");

	         Elements tableRowElements = tableElements.select(":not(thead) tr");

	         for (int i = 0; i < tableRowElements.size(); i++) {
	            Element row = tableRowElements.get(i);
	    		
	            Elements rowItems = row.select("td");
	            KGenomes kgen = new KGenomes();
	       System.out.println(rowItems.size());
	            for (int j = 0; j < rowItems.size(); j++) {
	            	
	            	if (j==0){
	            		System.out.println(rowItems.get(j).text() );
	            		if ((rowItems.get(j).text().contains("AFR") || rowItems.get(j).text().contains("EUR") ||
	            				rowItems.get(j).text().contains("AMR") || rowItems.get(j).text().contains("ASN"))&& 
	            				rowItems.get(j).text().contains("1000GENOMES:phase_1")){
	            			kgen = new KGenomes();
	            		//	System.out.print("\n"+rowItems.get(j).text() + " " );
	            			kgen.setName(rowItems.get(j).text());
	            		}
	            		else{
	            			kgen.setName("");
	            			break;
	            		}
            	}
	        	else if (j==rowItems.size()-2) //column Genotype count
	        		{
	        		String count = rowItems.get(j).text().replace("/", "").replace("(", "").replace(")", "").replace("|", "");
	        		kgen.setCount(count);
	        		int sum =0;

	          	  Pattern p = Pattern.compile("\\d+");
	          	  java.util.regex.Matcher m = p.matcher(count); 
	          	  while (m.find()) {
	          	     sum+=Integer.valueOf(m.group());
	          	  }
	          	  kgen.setSum(sum);	
	          	  int homoCount =0;
	          	  System.out.println("COUNT " + count);
	          	  StringTokenizer st = new StringTokenizer(count);
	        		while (st.hasMoreTokens()){
	        			int helpInt = Integer.valueOf(st.nextToken());
	        			String helpString = st.nextToken();
	        			if (helpString.charAt(0)==helpString.charAt(1)){
	        				
	        				if (homoCount==0)
	        					{
	        					kgen.setHomo1Count(helpInt);
	        					kgen.setHomo1Genotype(helpString);
	        					homoCount++;
	        					}
	        				else{
	        					kgen.setHomo2Count(helpInt);
	        					kgen.setHomo2Genotype(helpString);
	        				}
	        			}
	        			else{
	        				kgen.setHeteroCount(helpInt);
        					kgen.setHeteroGenotype(helpString);
	        		}
	        			}
	        		}
	           
	            else if (j==3 ) //column Genotypes AA
	    		{
	            	if (rowItems.get(j).hasText()){
	            		kgen.setHomo1(Double.valueOf(rowItems.get(j).text()));
	            	}
	            	else
	            		kgen.setHomo1(0.0);
	            	}
	            	
	            else if (j==4 )  //column Genotypes Aa
	    		{
	            	if (rowItems.get(j).hasText()){
	            	   	kgen.setHetero(Double.valueOf(rowItems.get(j).text()));
	            	}
	            	else
	            		kgen.setHetero(0.0);
	            	}
	            else if (j==5 ) //column Genotypes aa
	    		{ try{
	            	if (rowItems.get(j).hasText()){
	            		kgen.setHomo2(Double.valueOf(rowItems.get(j).text()));
	            	}
	            	else
	            		kgen.setHomo2(0.0);
	            	}catch(Exception numberformatException){
	            		System.out.println("empty");
	            	}
	    		}
	       }if (kgen.getName().length()>0)
	            kg.add(kgen);
	         }

	      } catch (IOException e) {
	         e.printStackTrace();
	      }
		return kg;
	}
}