package com.workflow.management;

import java.io.IOException;
import java.io.InputStream;
import java.net.URL;
import java.text.DecimalFormat;
import java.util.HashSet;
import java.util.Set;
import java.util.StringTokenizer;
import java.util.Vector;
import java.util.regex.Pattern;

import org.jsoup.Jsoup;
import org.jsoup.nodes.Document;
import org.jsoup.nodes.Element;
import org.jsoup.select.Elements;

import com.workflow.database.DatabaseUtils;
import com.workflow.database.beans.Hapmap;
import com.workflow.database.beans.Hwe;
import com.workflow.database.beans.Snp;
import com.workflow.management.util.CalcUtils;

public class Thread1000G extends Thread{
	Snp snp;
	 
	public Thread1000G(Snp snp) {
	this.snp = snp;
	}
	    public void run() {
	      
	            try {
	               append1000GENOMES(snp);
	            } catch (Exception e) {}
	        System.out.println("DONE! " + snp.getName() );
	        }

	    
	    private static void append1000GENOMES(Snp snp ) {
			Vector<KGenomes> kg =get1000Genomes(snp.getHapmapLookup());
			Set<Hapmap> hapmaps = new HashSet<Hapmap>();
			
			for (int i =0; i < kg.size(); i++){
				Hapmap hm = new Hapmap();
				hm.setPopulation(kg.get(i).getName());
				hm.setTotal(kg.get(i).getSum());
				
				int helpHomo1=kg.get(i).getHomo1Count();
				int helpHomo2=kg.get(i).getHomo2Count();
				
				//change 
				if (snp.getNameHomo1().equals(kg.get(i).getHomo2Genotype()) && snp.getNameHomo2().equals(kg.get(i).getHomo1Genotype())){
					System.out.println("HITTED match " + snp.getHapmapLookup());
					helpHomo1=kg.get(i).getHomo2Count();
					helpHomo2=kg.get(i).getHomo1Count();
				}

				else if (!snp.getNameHomo1().equals(kg.get(i).getHomo1Genotype())){
	System.out.println("Not matched " + snp.getHapmapLookup());
					if ((kg.get(i).getHomo1Genotype().equals("AA") && snp.getNameHomo1().equals("TT")) ||
						(kg.get(i).getHomo1Genotype().equals("CC") && snp.getNameHomo1().equals("GG"))){
						    helpHomo1 = kg.get(i).getHomo1Count();
						    helpHomo2 = kg.get(i).getHomo2Count();

					} else if ((kg.get(i).getHomo1Genotype().equals("AA") && snp.getNameHomo2().equals("TT")) ||
							   (kg.get(i).getHomo1Genotype().equals("CC") && snp.getNameHomo2().equals("GG"))) {
							helpHomo1 = kg.get(i).getHomo2Count();
							helpHomo2 = kg.get(i).getHomo1Count();
							
					} else if ((kg.get(i).getHomo1Genotype().equals("TT") && snp.getNameHomo1().equals("AA")) ||
							   (kg.get(i).getHomo1Genotype().equals("GG") && snp.getNameHomo1().equals("CC"))) {
							helpHomo1 = kg.get(i).getHomo1Count();
							helpHomo2 = kg.get(i).getHomo2Count();
					
					} else if ((kg.get(i).getHomo1Genotype().equals("TT") && snp.getNameHomo2().equals("AA")) ||
							   (kg.get(i).getHomo1Genotype().equals("GG") && snp.getNameHomo2().equals("CC"))) {
							helpHomo1 = kg.get(i).getHomo2Count();
							helpHomo2 = kg.get(i).getHomo1Count();
					
						}
					}
				
				double chi = calcHapmapChi(snp, helpHomo1, kg.get(i).getHeteroCount(), helpHomo2);
				hm.setChi(chi);
				hm.setHetero(kg.get(i).getHeteroCount());
				hm.setHeteroFreq(kg.get(i).getHetero());
				hm.setHomo1(helpHomo1);
				DecimalFormat df = new DecimalFormat("#.###");
				hm.setHomoFreq1(Double.valueOf(df.format(1.0*helpHomo1/kg.get(i).getSum()).replace(",",".")));
				hm.setHomo2(helpHomo2);
				hm.setHomoFreq2(Double.valueOf(df.format(1.0*helpHomo2/kg.get(i).getSum()).replace(",",".")));
				hm.setSnp(snp);
				hapmaps.add(hm);
			}
			DatabaseUtils.add(hapmaps);
		}
	    
	    private static Vector<KGenomes> get1000Genomes(String snpname) {
			Vector<KGenomes> kg = new Vector<KGenomes>();
			try {
		        
		         URL url = new URL("http://www.ensembl.org/Homo_sapiens/Component/Variation/Web/PopulationGenotypes?db=core;v="+snpname );
		         InputStream is = url.openConnection().getInputStream();

		         
		         Document doc = Jsoup.parse(is, "UTF-8", "http://www.ensembl.org");
		         Elements tableElements = doc.select("table");
		         
		         Elements tableRowElements = tableElements.select(":not(thead) tr");

		         for (int i = 0; i < tableRowElements.size(); i++) {
		            Element row = tableRowElements.get(i);
		            Elements rowItems = row.select("td");
		            KGenomes kgen = new KGenomes();
		            for (int j = 0; j < rowItems.size(); j++) {
		            	   	if (j==0){
			            		if ((rowItems.get(j).text().contains("AFR") || rowItems.get(j).text().contains("EUR") ||
			            				rowItems.get(j).text().contains("AMR") || rowItems.get(j).text().contains("ASN"))&& 
			            				rowItems.get(j).text().contains("1000GENOMES:phase_1")){
			            			kgen = new KGenomes();
			            		//	System.out.print("\n"+rowItems.get(j).text() + " " );
			            			kgen.setName(rowItems.get(j).text());
			            		}
			            		else{
			            			kgen.setName("");
			            			break;
			            		}
		            	}
			        	else if (j==(rowItems.size()-2)) //column Genotype count can vary for X chromosome +1, for others -1 (2 genotypes only)
			        		{
			        		String count = rowItems.get(j).text().replace("/", "").replace("(", "").replace(")", "").replace("|", "");
			        		kgen.setCount(count);
			        		int sum =0;

			          	  Pattern p = Pattern.compile("\\d+");
			          	  java.util.regex.Matcher m = p.matcher(count); 
			          	  while (m.find()) {
			          	     sum+=Integer.valueOf(m.group());
			          	  }
			          	  kgen.setSum(sum);	
			          	  int homoCount =0;
			          	  StringTokenizer st = new StringTokenizer(count);
			        		while (st.hasMoreTokens()){
			        			int helpInt = Integer.valueOf(st.nextToken());
			        			String helpString = st.nextToken();
			        			if (helpString.charAt(0)==helpString.charAt(1)){
			        				
			        				if (homoCount==0)
			        					{
			        					kgen.setHomo1Count(helpInt);
			        					kgen.setHomo1Genotype(helpString);
			        					homoCount++;
			        					}
			        				else{
			        					kgen.setHomo2Count(helpInt);
			        					kgen.setHomo2Genotype(helpString);
			        				}
			        			}
			        			else{
			        				kgen.setHeteroCount(helpInt);
		        					kgen.setHeteroGenotype(helpString);
			        		}
			        			}
			        		}
			           
		           
		            else if (j==3 ) //column Genotypes AA
		    		{
		            	if (rowItems.get(j).hasText()){
		            		kgen.setHomo1(Double.valueOf(rowItems.get(j).text()));
		            	}
		            	else
		            		kgen.setHomo1(0.0);
		            	}
		            	
		            else if (j==4 )  //column Genotypes Aa
		    		{
		            	if (rowItems.get(j).hasText()){
		            	   	kgen.setHetero(Double.valueOf(rowItems.get(j).text()));
		            	}
		            	else
		            		kgen.setHetero(0.0);
		            	}
		            else if (j==5 ) //column Genotypes aa
		    		{ try{
		            	if (rowItems.get(j).hasText()){
		            		kgen.setHomo2(Double.valueOf(rowItems.get(j).text()));
		            	}
		            	else
		            		kgen.setHomo2(0.0);
		            	
		    		}catch(Exception numberformatException){
	            		    kgen.setHomo2(0.0);     	
	            		    }
		    		}
		       }if (kgen.getName().length()>0)
		            kg.add(kgen);
		         }

		      } catch (IOException e) {
		         e.printStackTrace();
		      }
			return kg;
		}
	    
		private static double calcHapmapChi(Snp snp, double homo1, double hetero, double homo2) {
			final Hwe hwe = snp.getHwe();

			double sum1 = ((double)hwe.getHomoObserved1() + (double)hwe.getHeteroObserved() + (double)hwe.getHomoObserved2());
			double sum2 = (double)hwe.getHomoObserved1() + homo1;
			double sum3 = homo1 + hetero + homo2 + (double)hwe.getHomoObserved1() + (double)hwe.getHeteroObserved() + (double)hwe.getHomoObserved2();
			double sum4 = (double)hwe.getHeteroObserved() + hetero;
			double sum5 = (double)hwe.getHomoObserved2() + homo2;
			double sum6 = homo1 + hetero + homo2;

			double ownExHo1 = (sum1 * sum2) / sum3;
			double ownExHet = (sum1 * sum4) / sum3;
			double ownExHo2 = (sum1 * sum5) / sum3;
			double hapExHo1 = (sum6 * sum2) / sum3;
			double hapExHet = (sum6 * sum4) / sum3;
			double hapExHo2 = (sum6 * sum5) / sum3;

			//((B13-G13)^2)/G13+((C13-H13)^2)/H13+((D13-I13)^2)/I13+((B14-G14)^2)/G14+((C14-H14)^2)/H14+((D14-I14)^2)/I14
			double chi =((Math.pow(homo1-hapExHo1, 2))/hapExHo1)+((Math.pow(hetero-hapExHet, 2))/hapExHet)+((Math.pow(homo2-hapExHo2, 2))/hapExHo2)+((Math.pow(hwe.getHomoObserved1()-ownExHo1, 2))/ownExHo1)+((Math.pow(hwe.getHeteroObserved()-ownExHet, 2))/ownExHet)+((Math.pow(hwe.getHomoObserved2()-ownExHo2, 2))/ownExHo2);
			double p = CalcUtils.calc_x_df(chi, 2);

			return Double.isNaN(p) ? 0.0 : p;
		}
}
