package com.workflow.management;

import java.util.List;
import java.util.Locale;
import java.util.ResourceBundle;

import javax.naming.AuthenticationException;

import org.apache.log4j.Logger;

import net.sf.json.JSONArray;
import net.sf.json.JSONObject;

import com.workflow.database.DatabaseUtils;
import com.workflow.database.beans.User;
import com.workflow.util.StringUtils;

public class UserManagement {
	private static final Logger logger = Logger.getLogger(StudyManagement.class);
	
	public static void insertUser(String username, String password, int admin){
		User user = new User();
		logger.info("user: " +  username + " " + password + "  " + admin +"::::::");
		user.setUsername(username);
		user.setPassword(StringUtils.encodeMD5(password.toLowerCase()));
		user.setAdmin(admin);
		DatabaseUtils.add(user);
	}

	public static void updateUser(String id, String username, String password, int admin, String permissions){
		
		if (password.trim().length()!=0){
		User user = new User();
		user.setId(Integer.parseInt(id));
		user.setUsername(username);
		user.setPassword(StringUtils.encodeMD5(password.toLowerCase()));
		user.setAdmin(admin);
		DatabaseUtils.update(user);
		}
		else{ // no password provided
			User user = new User();
			user.setId(Integer.parseInt(id));
			String pwd = getUserFromId(id, username); 
						
			user.setAdmin(admin);
			user.setUsername(username);
			if (pwd!=null){
				user.setPassword(pwd);
			}
			
			DatabaseUtils.merge(user);
		}
	}

	private static String getUserFromId(String id, String username) {
		//User user = new User();
		//user.setId(Integer.parseInt(id));
		//user.setUsername(username);
		List<User> list = DatabaseUtils.getbyId(User.class, Integer.parseInt(id));
	
		String result="";
		
	
		if(list.size() == 1){
			User userFound = list.get(0);
			result= userFound.getPassword();
		}
		return result;
	}
	

	public static void deleteUser(String id){
		User user = DatabaseUtils.get(User.class, Integer.parseInt(id));
		DatabaseUtils.delete(user);
	}

	public static JSONObject getUsers(Locale locale){
		ResourceBundle labels = ResourceBundle.getBundle("workflow", locale);
		List<User> users = DatabaseUtils.getAllEntities(User.class);

		JSONObject result = new JSONObject();
		JSONArray ar = new JSONArray();
		for(User user : users){
			JSONObject tmp = new JSONObject();
			tmp.element("id", user.getId());
			tmp.element("username", user.getUsername());
		
			tmp.element("admin_id", user.getAdmin());
			switch(user.getAdmin()){
			case 0: tmp.element("admin_value", labels.getString("lbUserRoleAnalyst")); break;
			case 1: tmp.element("admin_value", labels.getString("lbUserRoleAdmin")); break;
			case 2: tmp.element("admin_value", labels.getString("lbUserRoleLab")); break;
			}
			
			ar.add(tmp);
		}

		result.element("data", ar);

		return result;
	}
}