package com.workflow.servlet;

import java.io.IOException;
import java.io.InputStream;
import java.util.LinkedList;
import java.util.List;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.fileupload.FileItemIterator;
import org.apache.commons.fileupload.FileItemStream;
import org.apache.commons.fileupload.FileUploadException;
import org.apache.commons.fileupload.servlet.ServletFileUpload;
import org.apache.commons.fileupload.util.Streams;

import com.workflow.management.ProbeImporter;
import com.workflow.management.StudyManagement;

@SuppressWarnings("serial")
public class AddSampleServlet extends HttpServlet {

    public AddSampleServlet() {
        super();
    }

	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		processRequest(request, response);
	}

	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		processRequest(request, response);
	}

	private void processRequest(HttpServletRequest request,	HttpServletResponse response) {
		boolean isMultipart = ServletFileUpload.isMultipartContent(request);
		if (isMultipart) {
			try {
				handleFileUpload(request);
				response.setContentType("text/html");
				response.getWriter()
						.write("<html><body><textarea>{\"response\":{\"message\":\"\"},\"success\":true}</textarea></body></html>");
			} catch (Exception e) {

				response.setContentType("text/html");
				try {
					response.getWriter()
							.write("<html><body><textarea>{\"response\":{\"message\":\"\"},\"success\":false}</textarea></body></html>");
				} catch (IOException e1) {
					e1.printStackTrace();
				}
			}
		}
	}

	private void handleFileUpload(HttpServletRequest request) throws FileUploadException, IOException{
		// Create a new file upload handler
		ServletFileUpload upload = new ServletFileUpload();

		// Parse the request
		FileItemIterator iter = upload.getItemIterator(request);
		String studyId = null;
		List<String> samples = new LinkedList<String>();

		while (iter.hasNext()) {
		    FileItemStream item = iter.next();
		    String fieldName = item.getFieldName();
		    InputStream stream = item.openStream();

		    if(fieldName.equals("study.id"))
		    	studyId = Streams.asString(stream);

		    if (!item.isFormField()) {
		    	samples = ProbeImporter.parseSampleIds(stream, item.getContentType());
		    }
		}

		if(samples.size() > 0)
			StudyManagement.importSampleIds(samples, Integer.valueOf(studyId));
	}
}
