package com.workflow.servlet;

import java.io.IOException;
import java.io.PrintWriter;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.apache.log4j.Logger;

import com.workflow.database.beans.User;
import com.workflow.management.AuthenticationManager;

@SuppressWarnings("serial")
public class AuthenticationServlet extends HttpServlet {
	private static final Logger logger = Logger.getLogger(AuthenticationServlet.class);
	
    public AuthenticationServlet() {
    }

	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		processRequest(request, response);
	}

	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		processRequest(request, response);
	}

	
	private void processRequest(HttpServletRequest request, HttpServletResponse response){
		String username = request.getParameter("username");
		String password = request.getParameter("password");
		String logout = request.getParameter("logout");
		logger.info("user: " + username + "tried to connect");
		PrintWriter out;
		
		if(username != null && username.length() > 0){
			boolean isSuccess = false;
			try {
				try{
					User user = AuthenticationManager.loginUser(username, password);
					HttpSession httpSession = request.getSession();
					httpSession.setAttribute("loggedInUser", user);
					isSuccess = true;
				} catch (Exception e) {	
					HttpSession httpSession = request.getSession();
					httpSession.setAttribute("success", false);
				
					logger.error("Authentication failes:: ", e);
				}				
				out = response.getWriter();
				out.write("{success: "+String.valueOf(isSuccess)+"}");
				out.close();
			} catch (IOException e){}
		} else if(logout != null){
			//logout requested
			HttpSession httpSession = request.getSession(false);
			if(httpSession != null)
				httpSession.invalidate();
		}		
	}
}
