package com.workflow.servlet;

import java.io.IOException;
import java.io.InputStream;
import java.util.HashMap;
import java.util.List;
import java.util.concurrent.ConcurrentHashMap;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.fileupload.FileItemIterator;
import org.apache.commons.fileupload.FileItemStream;
import org.apache.commons.fileupload.FileUploadException;
import org.apache.commons.fileupload.servlet.ServletFileUpload;
import org.apache.commons.fileupload.util.Streams;
import org.apache.log4j.Logger;

import com.workflow.management.DataImporter;
import com.workflow.management.beans.ExampleHolder;

@SuppressWarnings("serial")
public class DataUploadServlet extends AbstractServlet {
	private static final Logger logger = Logger.getLogger(DataUploadServlet.class);

    public DataUploadServlet() {
        super();
    }

	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		processRequest(request, response);
	}

	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		processRequest(request, response);
	}

	private void processRequest(HttpServletRequest request, HttpServletResponse response){
		boolean isMultipart = ServletFileUpload.isMultipartContent(request);
		if(isMultipart){
			try {
				handleFileUpload(request);
				response.setContentType("text/html");
				response.getWriter().write("<html><body><textarea>{\"response\":{\"message\":\"\"},\"success\":true}</textarea></body></html>");
			} catch (Exception e) {//FileUploadException, IOException
				response.setContentType("text/html");
				try {
					response.getWriter().write("<html><body><textarea>{\"response\":{\"message\":\"\"},\"success\":false}</textarea></body></html>");
				} catch (IOException e1) {
							}
				logger.error("Error while handling file upload::", e);
			}
		} else {
			throw new IllegalArgumentException("No data file given");
		}
	}

	private void handleFileUpload(HttpServletRequest request) throws FileUploadException, Exception{
		// Create a new file upload handler
		ServletFileUpload upload = new ServletFileUpload();

		// Parse the request
		FileItemIterator iter = upload.getItemIterator(request);
		ConcurrentHashMap<String, List<ExampleHolder>> dataMap = null;
		String fileFormat="";
		String labelFolder="";
		while (iter.hasNext()) {
			FileItemStream item = iter.next();
	
			InputStream stream = item.openStream();
		    
		
			if(item.getFieldName().equals("buttonMethod")){
		    	fileFormat=Streams.asString(stream)+"";
			}
			if(item.getFieldName().equals("snpDirectory")){
		    	labelFolder=Streams.asString(stream)+"";
			}
	    	
		    if (!item.isFormField()) {

		    	if(item.getName().isEmpty()) throw new FileUploadException("emptyFilename"){};
		    if (fileFormat.equals("1"))
		    	request.getSession(false).setAttribute("labelfolder", "");
		    if (fileFormat.equals("2"))
		    	request.getSession(false).setAttribute("labelfolder", labelFolder);
		    if (fileFormat.equals("3"))
		    	throw new FileUploadException();//request.getSession(false).setAttribute("labelfolder", labelFolder);
		    
		    	dataMap = DataImporter.processFile(stream, item.getContentType(), fileFormat, item.getName() );
		    	request.getSession(false).setAttribute("newDataList", dataMap);
		    
		    	if(stream != null)
		    		stream.close();
		    }
		  
		    
		   
		}
	}
}
