package com.workflow.servlet;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.util.Properties;

import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;

import org.apache.log4j.HTMLLayout;
import org.apache.log4j.Level;
import org.apache.log4j.Logger;

import org.apache.log4j.DailyRollingFileAppender;

import com.workflow.database.HibernateConfiguration;

@SuppressWarnings("serial")
public class InitServlet extends HttpServlet {
	private static final Logger logger = Logger.getLogger(InitServlet.class);
	public static String dbSchemaname="";
    public InitServlet() {
        super();
    }

	public void init(ServletConfig config) throws ServletException {
		//TODO initLog4j("/home/schoenherr/log.out");
		
		    super.init(config);
		    String path = config.getServletContext().getRealPath("/WEB-INF");
			
		Properties prop = new Properties();
		try {
			FileInputStream in = new FileInputStream(new File(path+File.separator+"snpflow.conf"));
			prop.load(in);
		} catch (Exception e) {//FileNotFoundException, IOException
			logger.error("Error reading config file: " + e.getMessage());
			e.printStackTrace();
		}

		String dbUsername = prop.getProperty("username");
		String dbPasswd = prop.getProperty("password");
		String dbHostname = prop.getProperty("hostname");
		dbSchemaname = prop.getProperty("schemaname");
		System.out.println("------- SCHEMA + " +dbSchemaname);
		
		String showSQL = prop.getProperty("showSQL");
		String db = prop.getProperty("db");
		HibernateConfiguration.initialize(dbUsername, dbPasswd, dbHostname, dbSchemaname, showSQL, path, db);
		if(!HibernateConfiguration.testDBConnection()){
			logger.error("DB connection failure, could not initialize DB");
		}
		logger.info("Successfully initialized WorkflowManager");
	}

	private void initLog4j(String logFile) {
		Logger.getLogger("com.workflow").setLevel(Level.toLevel("5"));

		try {
			HTMLLayout layout = new HTMLLayout();
			layout.setTitle("WorkflowManager Logfile");
			DailyRollingFileAppender fileAppender =
				new DailyRollingFileAppender( layout, logFile, "'.'yyyy-MM-dd_HH-mm" );
			logger.addAppender( fileAppender );
		} catch (IOException e) {
			System.err.println("ERROR while initializing logging: Could not open/create log file.");
		}
	}
}
