package com.workflow.servlet;

import java.io.IOException;
import java.io.InputStream;
import java.util.HashMap;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.fileupload.FileItemIterator;
import org.apache.commons.fileupload.FileItemStream;
import org.apache.commons.fileupload.FileUploadException;
import org.apache.commons.fileupload.servlet.ServletFileUpload;
import org.apache.commons.fileupload.util.Streams;

import com.workflow.management.ProbeImporter;
import com.workflow.management.StudyManagement;

@SuppressWarnings("serial")
public class SampleServlet extends HttpServlet {
	public SampleServlet() {
        super();
    }

	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		processRequest(request, response);
	}

	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		processRequest(request, response);
	}

	private void processRequest(HttpServletRequest request, HttpServletResponse response){
		boolean isMultipart = ServletFileUpload.isMultipartContent(request);
		if(isMultipart){
			try {
				handleFileUpload(request);
			} catch (FileUploadException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
	}
	
	private void handleFileUpload(HttpServletRequest request) throws FileUploadException, IOException{
		// Create a new file upload handler
		ServletFileUpload upload = new ServletFileUpload();

		// Parse the request
		FileItemIterator iter = upload.getItemIterator(request);
		String studyId = null;
		String datatype = null;
		HashMap<String, String[]> samples = new HashMap<String, String[]>();
		
		while (iter.hasNext()) {
		    FileItemStream item = iter.next();
		    String fieldName = item.getFieldName();
		    InputStream stream = item.openStream();
		    
		    if(fieldName.equals("study.id"))
		    	studyId = Streams.asString(stream);
		    else if(fieldName.equals("datatype"))
		    	datatype = Streams.asString(stream);
		    
		    if (!item.isFormField()) {
		    	if(datatype.equalsIgnoreCase("nanodrop")){
		    		samples = ProbeImporter.parseSamplesNanodrop(stream); 
		    	} else{
		    		samples = ProbeImporter.parseSamplesNanoquand(stream);
		    	}
		    }
		}
		
		if(samples.size() > 0)
			StudyManagement.importSamples(studyId, samples);
	}
}
