package com.workflow.servlet;

import java.io.IOException;
import java.io.InputStream;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.fileupload.FileItemIterator;
import org.apache.commons.fileupload.FileItemStream;
import org.apache.commons.fileupload.FileUploadException;
import org.apache.commons.fileupload.servlet.ServletFileUpload;
import org.apache.commons.fileupload.util.Streams;
import org.apache.log4j.Logger;

import com.workflow.management.DataImporter;
import com.workflow.management.beans.ExampleHolder;
import com.workflow.management.beans.SexSnpHolder;

@SuppressWarnings("serial")
public class SexSnpDataUploadServlet extends AbstractServlet {
	private static final Logger logger = Logger.getLogger(SexSnpDataUploadServlet.class);
	public static String firstSex;
	public static String secondSex;
	public static ConcurrentHashMap<String, List<SexSnpHolder>> dataList;
	
    public SexSnpDataUploadServlet() {
        super();
    }

	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		processRequest(request, response);
	}

	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		processRequest(request, response);
	}

	private void processRequest(HttpServletRequest request, HttpServletResponse response){
		boolean isMultipart = ServletFileUpload.isMultipartContent(request);
		if(isMultipart){
			try {
				handleFileUpload(request);
				response.setContentType("text/html");
				response.getWriter().write("<html><body><textarea>{\"response\":{\"message\":\"\"},\"success\":true}</textarea></body></html>");
			} catch (Exception e) {//FileUploadException, IOException
				response.setContentType("text/html");
				try {
					response.getWriter().write("<html><body><textarea>{\"response\":{\"message\":\"\"},\"success\":false}</textarea></body></html>");
				} catch (IOException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				}
				logger.error("Error while handling file upload::", e);
			}
		} else {
			throw new IllegalArgumentException("No data file given for SexSnp");
		}
	}

	private void handleFileUpload(HttpServletRequest request) throws FileUploadException, IOException{
		// Create a new file upload handler
		ServletFileUpload upload = new ServletFileUpload();
System.out.println("SEXSNP comes");
		// Parse the request
		FileItemIterator iter = upload.getItemIterator(request);
	
	

		while (iter.hasNext()) {
			FileItemStream item = iter.next();
	
			InputStream stream = item.openStream();
		    
	    	
		    if (!item.isFormField()) {

		    	if(item.getName().isEmpty()) throw new FileUploadException("emptyFilename"){};

		   	dataList = DataImporter.processFileSexSnp(stream, item.getContentType(), item.getName() );
		 
		   	List<SexSnpHolder> sh= dataList.get("key");
		   	System.out.println("LIST " + sh);
		   	 firstSex="";
		   	 secondSex="";
		   	
		   	for (int i =0; i < sh.size(); i++){
		   		String help = sh.get(i).toString().split("\t")[1];
		   		if (firstSex.equals(""))
		   			firstSex=help;
		   		else if (!firstSex.equals(help))
		   			secondSex=help;
		   			
		   		if (!help.equals(firstSex) && !help.equals(secondSex)){
		   			logger.error("more than 2 different genders found::");
				    
		   		}
		   	}
		    
		    	Map<Integer, String> m1 = new HashMap<Integer, String>();
		    	m1.put(1, firstSex);
		    	m1.put(2, secondSex);
		    	System.out.println(m1);
			    	
		    	if(stream != null)
		    		stream.close();
		    }
		  
		    
		   
		}
	}
}
