package com.workflow.servlet;

import java.util.Iterator;
import java.util.Locale;
import java.util.Map;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import net.sf.json.JSONArray;
import net.sf.json.JSONNull;
import net.sf.json.JSONObject;

import com.workflow.database.beans.User;
import com.workflow.management.UserManagement;


@SuppressWarnings("serial")
public class UserServlet extends AbstractServlet {
	public UserServlet() {
        super();
    }

	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException {
		processRequest(request, response);
	}

	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException {
		processRequest(request, response);
	}

	private void processRequest(HttpServletRequest request, HttpServletResponse response){
		String requestType = request.getParameter("xaction");
		final Locale locale = request.getLocale();

		String data = request.getParameter("data");
	
		
		try {
			if(requestType.equals("create")){
				JSONObject jo = JSONObject.fromObject(data);
				String username = jo.getString("username");
				String password = jo.getString("password");
				String admString = jo.getString("admin_value");
				int admin =-1;
				admin = getIdfromAdminValue(admString);
			
				if (username.length()>0 && password.length() >0 && admString.length()>0) {
					UserManagement.insertUser(username, password, admin);
				}
				setResponse(response, "{success: true}");
			} 
			else if(requestType.equals("update")){
				JSONObject jo = JSONObject.fromObject(data);
				String username = jo.getString("username");
				String password = jo.getString("password");
				String admin_value= jo.getString("admin_value");
			
				int admin=0;
				admin = getIdfromAdminValue(admin_value);
				
				String permissions = "";//jo.getString("permissions");
				String id = jo.getString("id");
				if (password.isEmpty()){
					UserManagement.updateUser(id, username, "", admin, permissions);
				}
				else{
					UserManagement.updateUser(id, username, password, admin, permissions);
				}
				setResponse(response, "{success: true}");
			} else if(requestType.equals("destroy")) {
				String id = request.getParameter("data");
				UserManagement.deleteUser(id);
				setResponse(response, "{success: true}");
			} else if(requestType.equals("read")) {
				
				JSONObject users = UserManagement.getUsers(locale);
				setResponse(response, users.toString());
			
			} else if(requestType.equals("getUser")) {
				User user = (User) request.getSession(false).getAttribute("loggedInUser");
				JSONObject jUser = new JSONObject();
				jUser.element("id", user.getId());
				jUser.element("username", user.getUsername());
				jUser.element("password", user.getPassword());
				jUser.element("admin", user.getAdmin());
				setResponse(response, jUser.toString());
			}
		} catch(Exception e){
			e.printStackTrace();
			setResponse(response, "{success: false}");
		}
	}

	private int getIdfromAdminValue(String admin_value) {
		int admin=0;
		if (admin_value.equals("Lab")) 
				 admin = 2;
		if (admin_value.equals("Admin")) 
			 admin =1;
		if (admin_value.equals("Analyst")) 
			 admin =0;
		return admin;
	}
}
