package com.workflow.util;

import java.io.UnsupportedEncodingException;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;

public abstract class StringUtils {
	
	public static String encodeMD5(final String string) {
		try {
			return byteArrayToHexString(encode(string, "MD5"));
		} catch (final NoSuchAlgorithmException e) {
			// ignore NoSuchAlgorithmException
		}

		return "";
	}
	
	private static String byteArrayToHexString(final byte[] data) {
		final StringBuilder encodedPassword = new StringBuilder();

		int k;
		for (final byte element : data) {
			k = element;
			k = (k & 0x7F) + (k < 0 ? 128 : 0);
			String strValue = (k < 16 ? "0" : "");
			strValue += Integer.toHexString(k).toUpperCase();
			encodedPassword.append(strValue);
		}

		return encodedPassword.toString();
	}
	
	private static byte[] encode(final String string, final String method) throws NoSuchAlgorithmException {
		try {
			return encode(string.getBytes("ISO-8859-1"), method);
		} catch (final UnsupportedEncodingException uee) {
			// encoding is not supported... try with OS default encoding
			return encode(string.getBytes(), method);
		}
	}
	
	private static byte[] encode(final byte[] byteArr, final String method) throws NoSuchAlgorithmException {
		final MessageDigest sha = MessageDigest.getInstance(method);
		return sha.digest(byteArr);
	}
}