-- MySQL dump 10.13  Distrib 5.1.41, for Win32 (ia32)
--
-- Host: localhost    Database: WORKFLOW
-- ------------------------------------------------------
-- Server version	5.1.41

--
-- Table structure for table  study 
--

DROP schema IF EXISTS  WORKFLOW ;
create schema WORKFLOW;
set schema WORKFLOW;

DROP TABLE IF EXISTS  study ;

CREATE TABLE  STUDY  (
   ID  int(10) unsigned NOT NULL AUTO_INCREMENT,
   NAME  varchar(250) NOT NULL,
   DESCRIPTION  varchar(250) DEFAULT NULL,
   IDENTIFIER  varchar(45) NOT NULL,
   NUM_MULTIPLE  int(10) unsigned NOT NULL,
   ACTIVE  tinyint(1) NOT NULL,
  PRIMARY KEY ( ID )
);

--
-- Table structure for table  hwe 
--

DROP TABLE IF EXISTS  hwe ;
DROP TABLE IF EXISTS  hwe ;

CREATE TABLE  HWE  (
   ID  int(10) unsigned NOT NULL AUTO_INCREMENT,
   CHI_SQUARE  double NOT NULL,
   EXACT  double NOT NULL,
   HOMO_OBSERVED1  int(10) unsigned NOT NULL,
   HOMO_OBSERVED2  int(10) unsigned NOT NULL,
   HETERO_OBSERVED  int(10) unsigned NOT NULL,
   HOMO_EXPECTED1  double NOT NULL,
   HOMO_EXPECTED2  double NOT NULL,
   HETERO_EXPECTED  double NOT NULL,
  PRIMARY KEY ( ID )
);


--
-- Table structure for table  snp 
--

DROP TABLE IF EXISTS  snp ;

CREATE TABLE  SNP  (
   ID  int(10) unsigned NOT NULL AUTO_INCREMENT,
   NAME  varchar(250) NOT NULL,
   CREATED_WHEN  datetime NOT NULL,
   NUM_MULTIPLE  int(10) unsigned NOT NULL,
   PROC_QC_SAMPLES  double NOT NULL,
   PROC_CALL_RATE  double NOT NULL,
   NUM_HOMO1  int(10) unsigned NOT NULL,
   NAME_HOMO1  varchar(45) NOT NULL,
   NUM_HOMO2  int(10) unsigned NOT NULL,
   NAME_HOMO2  varchar(45) NOT NULL,
   NUM_HETERO  int(10) unsigned NOT NULL,
   NAME_HETERO  varchar(45) NOT NULL,
   PROC_MAF  double NOT NULL,
   HWE_FK  int(10) unsigned NOT NULL,
   STUDY_FK  int(10) unsigned NOT NULL,
   NUM_SAMPLES  int(10) unsigned NOT NULL,
   PROC_DISC_RATE  double NOT NULL,
   NUM_DISC  int(10) unsigned NOT NULL,
   PROC_QC  double NOT NULL,
   SEX int(10) NOT NULL, 
   COMMENT  varchar(200) DEFAULT NULL,
   INSERTED_BY  varchar(100) NOT NULL,
   HAPMAP_FK  int(10) unsigned DEFAULT NULL,
   HAPMAP_LOOKUP  varchar(100) DEFAULT NULL,
   directory  varchar(100) DEFAULT NULL,
  PRIMARY KEY ( ID ),
  FOREIGN KEY ( HWE_FK ) REFERENCES  hwe  ( ID ),
  FOREIGN KEY ( STUDY_FK ) REFERENCES  study  ( ID )
);


--
-- Table structure for table  hapmap 
--

DROP TABLE IF EXISTS  hapmap ;

CREATE TABLE  HAPMAP  (
   id  int(10) unsigned NOT NULL AUTO_INCREMENT,
   POPULATION  varchar(45) NOT NULL,
   HOMO1  double NOT NULL,
   HOMO2  double NOT NULL,
   HETERO  double NOT NULL,
   TOTAL  int(10) unsigned NOT NULL,
   CHI  double NOT NULL,
   SNP_FK  int(10) unsigned NOT NULL,
   HOMO_FREQ1  double NOT NULL,
   HOMO_FREQ2  double NOT NULL,
   HETERO_FREQ  double NOT NULL,
  PRIMARY KEY ( id ),
  FOREIGN KEY ( SNP_FK ) REFERENCES  snp  ( ID )
);





--
-- Table structure for table  discordance 
--

DROP TABLE IF EXISTS  discordance ;

CREATE TABLE  DISCORDANCE  (
   ID  int(10) unsigned NOT NULL AUTO_INCREMENT,
   CALL_NAME  varchar(2) NOT NULL,
   WELL  varchar(45) NOT NULL,
   DISCORDANT  tinyint(1) NOT NULL,
   SNP_FK  int(10) unsigned NOT NULL,
   SAMPLE_ID  varchar(45) NOT NULL,
   file_name  varchar(100) DEFAULT NULL,
  PRIMARY KEY ( ID ),
  FOREIGN KEY ( SNP_FK ) REFERENCES  snp  ( ID )
);


--
-- Table structure for table  genotype 
--

DROP TABLE IF EXISTS  genotype ;

CREATE TABLE  GENOTYPE  (
   ID  int(10) unsigned NOT NULL AUTO_INCREMENT,
   SAMPLE_ID  varchar(250) NOT NULL,
   GENOTYPE  varchar(45) NOT NULL,
   SNP_FK  int(10) unsigned NOT NULL,
  PRIMARY KEY ( ID ),
 FOREIGN KEY ( SNP_FK ) REFERENCES  snp  ( ID ) ON DELETE NO ACTION ON UPDATE NO ACTION
);


--
-- Table structure for table  sample 
--


DROP TABLE IF EXISTS  sample ;

CREATE TABLE SAMPLE  (
   ID  int(10) unsigned NOT NULL AUTO_INCREMENT,
   SAMPLE_ID  varchar(250) NOT NULL,
   CONCENTRATION  varchar(250) DEFAULT NULL,
   QUALITY_VALUE  varchar(250) DEFAULT NULL,
   IS_ERROR  tinyint(1) NOT NULL,
   INSERTED_WHEN  datetime NOT NULL,
   STUDY_FK  int(10) unsigned NOT NULL,
  PRIMARY KEY ( ID ),
  UNIQUE KEY  UC_SAMPLE_ID  ( SAMPLE_ID , STUDY_FK ),
  FOREIGN KEY ( STUDY_FK ) REFERENCES  study  ( ID )
);



--
-- Table structure for table  user 
--
DROP TABLE IF EXISTS  user ;

CREATE TABLE  USER  (
   username  varchar(45) NOT NULL,
   password  varchar(45) NOT NULL,
   id  int(10) unsigned NOT NULL AUTO_INCREMENT,
   admin  int(1) DEFAULT NULL,
  PRIMARY KEY ( id ),
  UNIQUE KEY  UC_USERNAME  ( username )
);

insert into  USER   values ('admin', 'AAF71CEC550B5F233AD8F07BB122A344',1, 1);


--
-- Table structure for table  user 
--
DROP TABLE IF EXISTS  sexsnp ;

CREATE TABLE SEXSNP (
  ID int(10) NOT NULL AUTO_INCREMENT,
  SNP_FK int(10) NOT NULL,
  SAMPLE_ID varchar(250) DEFAULT NULL,
  GENOTYPE varchar(45) DEFAULT NULL,
  PHENOTYPE varchar(45) DEFAULT NULL,
  PRIMARY KEY (ID),
  FOREIGN KEY ( SNP_FK ) REFERENCES  snp  ( ID ) on delete cascade

); 

-- Dump completed on 2012-02-29 15:27:06
