Ext.namespace('workflow');

workflow.DeleteOverview = function(config) {
	Ext.apply(this, config,{});

	var me = this;
	
	this.store = new Ext.data.Store({
        reader: new Ext.data.JsonReader({
			id: 'name', 
			root: 'data',
			fields:[{
			    name: 'name',
			    type: 'string'
			}, {
			    name: 'nums',
			    type: 'int'
			}]
        }),
        proxy: new Ext.data.HttpProxy({timeout: 240000,url:'./SNPDataServlet'}),
        baseParams: {studyId: me.studyId, requestType: 'getDeleteOverview'},
        listeners: {
        	load: function(store, records, opts){
        		me.grid.getSelectionModel().selectAll();
        		workflow.LoadMask.hide();
        	}
        }
    });

	this.sm = new Ext.grid.CheckboxSelectionModel();
	this.grid = new Ext.grid.GridPanel({
		sm: this.sm,
		frame: true,
	    autoScroll: true,
        store: this.store,
        columns: [this.sm,
               {header: myLocale.lbMarker, width: 200, sortable: false, dataIndex: 'name'},
               {header: myLocale.lbCount, width: 200, sortable: true, dataIndex: 'nums'}
           ]
    });

	workflow.DeleteOverview.superclass.constructor.call(this, Ext.apply({
		layout: 'fit',
		title: myLocale.lbConfirmDelete,
		buttonAlign: 'right',
		items: this.grid
	}));
};

Ext.extend(workflow.DeleteOverview, Ext.ux.Wiz.Card, {
	wizRef: null,
	
	studyId: null,
	
	initWizCard: function(){
		workflow.LoadMask.show();
		this.store.load();
	},

	commitCard: function(respHandler){
		var me = this;
		workflow.LoadMask.show();
		var selections = this.sm.getSelections();
		var holder = [];
		for (var i = 0, l = selections.length; i<l; ++i) {
			holder.push({
				name: selections[i].id
			});
		}
		Ext.Ajax.request({
			url: './SNPDataServlet',
			success: function(){
				workflow.LoadMask.hide();
				respHandler(me.wizRef);
			},
			failure: function () {
				workflow.LoadMask.hide();
			},
			params: { 
				requestType: 'confirmDelete',
				studyId: me.studyId,
				sampleIds: Ext.util.JSON.encode(holder) 
			}
		});		
	}
});