Ext.namespace('workflow');

workflow.ExportSnp = function(config) {
	Ext.apply(this, config,{
		snpId: null, 
		multi: null
	});

	workflow.ExportSnp.superclass.constructor.call(this, Ext.apply({
		plain: true,
		modal: true,
		width: 400,
		height: 350,
		bodyStyle: 'padding: 10px 10px 10px 10px',
		layout: 'form',
		maximizable: false,
		resizable: false,
		closable: true,
		title: 'Export',
		iconCls: 'icon-window-export',
		items: {
			xtype: 'fieldset',
			title: myLocale.lbChoose,
			layout: 'form',
			items: [{
	        	xtype: 'checkbox',
	        	labelSeparator: '',
	    		hideLabel: true,
	    		hidden: true,
	    		checked: false,
	    		id: 'genotypes',
	    		boxLabel: myLocale.lbGenotypeTsv,
	        	fieldLabel: myLocale.lbGenotypeTsv
	    	},{
	        	xtype: 'checkbox',
	        	labelSeparator: '',
	    		hideLabel: true,
	    		hidden: true,
	    		checked: false,
	    		id: 'hapmap',
	    		boxLabel: myLocale.lbHapMapTsv,
	        	fieldLabel: myLocale.lbHapMapTsv
	    	},{
	        	xtype: 'checkbox',
	        	labelSeparator: '',
	    		hideLabel: true,
	    		hidden: true,
	    		checked: false,
	    		id: 'summary',
	    		boxLabel: myLocale.lbSummaryTsv,
	        	fieldLabel: myLocale.lbSummaryTsv
	    	},{
	        	xtype: 'checkbox',
	        	labelSeparator: '',
	    		hideLabel: true,
	    		hidden: true,
	    		checked: true,
	    		id: 'excel',
	    		name: 'excel',
	    		boxLabel: myLocale.lbSummaryGenotypeXls,
	        	fieldLabel: myLocale.lbSummaryGenotypeXls,
	            listeners: {
	                check: function(excel, checked) {
	                  if(!checked){
	                    Ext.getCmp('exportName').hide();
	                    Ext.getCmp('exportName').label.hide();
	                    Ext.getCmp('checkboxgroup').hide();
	                    Ext.getCmp('checkboxgroup1000').hide();
	                  } else {
	                    Ext.getCmp('exportName').show();
	                    Ext.getCmp('exportName').label.show();
	                    Ext.getCmp('checkboxgroup').show();
	                    Ext.getCmp('checkboxgroup1000').show();
	                  }
	                }
	            }
	    	},{
	    		xtype: 'textfield',
				id: 'exportName',
				name: 'exportName',
				emptyText: myLocale.lbMandatory1,
				tabIndex: 1,
				width: 230,
				allowBlank: false,
				fieldLabel: myLocale.lbExportFile, 
				 listeners: {
	                  invalid: function(field, msg)
	                        {
	                            Ext.Msg.alert('', msg);
	                        } 
	                 }
	    	}
	    	,
{
		        title: myLocale.lbHapMapPop,
		        id: 'checkboxgroup',
		        name: 'checkboxgroup',
		        width: 370,
		        height: 120,
		        bodyPadding: 10,
		        renderTo: Ext.getBody(),
		        items:[{
		            xtype: 'checkboxgroup',
		            fieldLabel: '3 Columns',
		            // Arrange radio buttons into two columns, distributed vertically
		            columns: 3,
		            vertical: true,
		            items: [
		                { boxLabel: 'ASW', name: 'cb1', id: 'cb1', inputValue: '1', tooltip: 'Longer description for the checkbox' },
		                { boxLabel: 'CEU', name: 'cb2', id: 'cb2', inputValue: '2', checked: true },
		                { boxLabel: 'CHB', name: 'cb3', id: 'cb3', inputValue: '3' },
		                { boxLabel: 'CHD', name: 'cb4', id: 'cb4', inputValue: '4' },
		                { boxLabel: 'GIH', name: 'cb5', id: 'cb5', inputValue: '5' },
		                { boxLabel: 'JPT', name: 'cb6', id: 'cb6', inputValue: '6' },
		                { boxLabel: 'LWK', name: 'cb7', id: 'cb7', inputValue: '7' },
		                { boxLabel: 'MEX', name: 'cb8', id: 'cb8', inputValue: '8' },
		                { boxLabel: 'MKK', name: 'cb9', id: 'cb9', inputValue: '9' },
		                { boxLabel: 'TSI', name: 'cb10', id: 'cb10', inputValue: '10' },
		                { boxLabel: 'YRI', name: 'cb11', id: 'cb11', inputValue: '11' },
		                { boxLabel: 'Select all', name: 'rb12', inputValue: '12',   listeners: {
			                check: function(rb12, checked) {
				                  if(checked){
		  		                   Ext.getCmp('cb1').setValue(true);
		  		                   Ext.getCmp('cb2').setValue(true);
		  		                   Ext.getCmp('cb3').setValue(true);
		  		                   Ext.getCmp('cb4').setValue(true);
		  		                   Ext.getCmp('cb5').setValue(true);
		  		                   Ext.getCmp('cb6').setValue(true);
		  		                   Ext.getCmp('cb7').setValue(true);
		  		                   Ext.getCmp('cb8').setValue(true);
		  		                   Ext.getCmp('cb9').setValue(true);
		  		                   Ext.getCmp('cb10').setValue(true); 
		  		                   Ext.getCmp('cb11').setValue(true);
		  		            
				                  
				                  } else {
				                	   Ext.getCmp('cb1').setValue(false);
				                	   Ext.getCmp('cb2').setValue(false);
			  		                   Ext.getCmp('cb3').setValue(false);
			  		                   Ext.getCmp('cb4').setValue(false);
			  		                   Ext.getCmp('cb5').setValue(false);
			  		                   Ext.getCmp('cb6').setValue(false);
			  		                   Ext.getCmp('cb7').setValue(false);
			  		                   Ext.getCmp('cb8').setValue(false);
			  		                   Ext.getCmp('cb9').setValue(false);
			  		                   Ext.getCmp('cb10').setValue(false); 
			  		                   Ext.getCmp('cb11').setValue(false);
				                  }
				                }
				            } }
		            ]
		        }]
		
},
{
		        title: "1000Genomes",
		        id: 'checkboxgroup1000',
		        name: 'checkboxgroup1000',
		        width: 370,
		        height: 120,
		        bodyPadding: 10,
		        renderTo: Ext.getBody(),
		        items:[{
		            xtype: 'checkboxgroup',
		            fieldLabel: '4 Columns',
		            // Arrange radio buttons into two columns, distributed vertically
		            columns: 4,
		            vertical: true,
		            items: [
		                { boxLabel: 'AFR', name: 'cb13', id: 'cb13', inputValue: '13', tooltip: 'Longer description for the checkbox' },
		                { boxLabel: 'AMR', name: 'cb14', id: 'cb14', inputValue: '14' },
		                { boxLabel: 'ASN', name: 'cb15', id: 'cb15', inputValue: '15' },
		                { boxLabel: 'EUR', name: 'cb16', id: 'cb16', inputValue: '16', checked: true },
		                { boxLabel: 'Select all', name: 'rb17', inputValue: '17',   listeners: {
			                check: function(rb17, checked) {
				                  if(checked){
		  		                   Ext.getCmp('cb13').setValue(true);
		  		                   Ext.getCmp('cb14').setValue(true);
		  		                   Ext.getCmp('cb15').setValue(true);
		  		                   Ext.getCmp('cb16').setValue(true);
				                  } else {
				                	   Ext.getCmp('cb13').setValue(false);
				                	   Ext.getCmp('cb14').setValue(false);
			  		                   Ext.getCmp('cb15').setValue(false);
			  		                   Ext.getCmp('cb16').setValue(false);
				                  }
				                }
				            } }
		            ]
		        }]
		
}


]		},
	   
		buttons: [{
			text: myLocale.lbOk,
			handler: function() {
				if (Ext.getCmp('excel').getValue() && Ext.getCmp('exportName').getValue().trim()== "")
					Ext.Msg.alert('', 'Export name emtpy');
				else if (Ext.getCmp('excel').getValue() || Ext.getCmp('genotypes').getValue() || Ext.getCmp('hapmap').getValue() || Ext.getCmp('summary').getValue())
						this.download();
				else
					Ext.Msg.alert('', 'No selection made');
			},
			scope: this
		}, {
			text: myLocale.lbCancel,
			handler: function() {
				this.close();
			},
			scope: this
		}],
		
		   keys: [{
	            key: [Ext.EventObject.ENTER],
	            handler: function(){
	            	if (Ext.getCmp('excel').getValue() && Ext.getCmp('exportName').getValue().trim()== "")
						Ext.Msg.alert('', 'Export name emtpy');
					else if (Ext.getCmp('excel').getValue() || Ext.getCmp('genotypes').getValue() || Ext.getCmp('hapmap').getValue() || Ext.getCmp('summary').getValue())
							this.download();
					else
						Ext.Msg.alert('', 'No selection made');
			
	            },
	            scope: this
	        }]
	}));
	
};

Ext.extend(workflow.ExportSnp, Ext.Window, {
	download: function() {
		var downStr = '';
		downStr += (Ext.getCmp("genotypes").checked) ? '&genotypes=true' : '';
		downStr += (Ext.getCmp("summary").checked) ? '&summary=true' : '';
		downStr += (Ext.getCmp("excel").checked) ? '&excel=true' : '';
		downStr += (Ext.getCmp("hapmap").checked) ? '&hapmap=true' : '';

		downStr += (Ext.getCmp("cb1").checked) ? '&cb1=true' : '';
		downStr += (Ext.getCmp("cb2").checked) ? '&cb2=true' : '';
		downStr += (Ext.getCmp("cb3").checked) ? '&cb3=true' : '';
		downStr += (Ext.getCmp("cb4").checked) ? '&cb4=true' : '';
		downStr += (Ext.getCmp("cb5").checked) ? '&cb5=true' : '';
		downStr += (Ext.getCmp("cb6").checked) ? '&cb6=true' : '';
		downStr += (Ext.getCmp("cb7").checked) ? '&cb7=true' : '';
		downStr += (Ext.getCmp("cb8").checked) ? '&cb8=true' : '';
		downStr += (Ext.getCmp("cb9").checked) ? '&cb9=true' : '';
		downStr += (Ext.getCmp("cb10").checked) ? '&cb10=true' : '';
		downStr += (Ext.getCmp("cb11").checked) ? '&cb11=true' : '';
		downStr += (Ext.getCmp("cb13").checked) ? '&cb13=true' : ''; //1000G
		downStr += (Ext.getCmp("cb14").checked) ? '&cb14=true' : ''; //1000G
		downStr += (Ext.getCmp("cb15").checked) ? '&cb15=true' : ''; //1000G
		downStr += (Ext.getCmp("cb16").checked) ? '&cb16=true' : ''; //1000G
		console.log(downStr);
		window.location.href =
			"./DownloadServlet?snpId="+this.snpId+"&downloadType=genotypes" + downStr + "&multi="+this.multi+ "&export="+Ext.getCmp("exportName").getValue();
		
		this.close();
	}
});