Ext.namespace('workflow');

workflow.ImportWizard = function(config) {
	Ext.apply(this, config,{});

	workflow.ImportWizard.superclass.constructor.call(this, Ext.apply({
		title: myLocale.lbCreateNewSnp,
		height: 445,
		previousButtonText: '&lt; ' + myLocale.lbBack,
		nextButtonText: myLocale.lbNext + ' &gt;',
		cancelButtonText: myLocale.lbCancel,
		finishButtonText: myLocale.lbFinish,
		onCancelClick: function(){
		Ext.Msg.confirm(myLocale.lbCancel, myLocale.lbConfirmCancel, function(btn, text){
	    	    if (btn == 'yes'){
	    	    	this.close();
	    	    }
	    	}, this);
		},
		headerConfig: {
			title: '<img src="./images/snpflow5s.png" />',
			stepText: '<br />' + myLocale.lbStepByStep
		},
		cards: [
		    new workflow.SnpFileUpload({wizRef: this, studyId: this.studyId}),
	        new workflow.DeleteOverview({wizRef: this, studyId: this.studyId}),
	        new workflow.SelectionBox({wizRef: this, studyId: this.studyId}),
		    
	       
	        new Ext.ux.Wiz.Card({
	        	title: myLocale.lbFinishedCreate,
	        	wizRef: this,
	        	initWizCard: function(){},
	        	commitCard: function(respHandler){
	        		respHandler(this.wizRef);
	        		workflow.study.getStudies(this.wizRef.snpId);
	        		//workflow.selectSnp(this.wizRef.snpId);
	        	},
	        	items: [{
	        		layout: 'form',
	        		height: 310,
	        		frame: true,
	        		border: true,
	        		bodyStyle: 'padding 25px',
	        		html: '<img src="./images/success.png" /> ' + myLocale.lbCreationSuccess
	        	}]
	        })]
	}));
};

Ext.extend(workflow.ImportWizard, Ext.ux.Wiz, {
	studyId: null,

	snpId: null,

    onNextClick: function() {
    	this.cards[this.currentCard].commitCard(this.successNext);
    },

	successNext: function(wizRef) {
		if (wizRef.currentCard == wizRef.cardCount-1) {
			wizRef.onFinish();
        } else {
        	wizRef.cards[wizRef.currentCard+1].initWizCard();
        	wizRef.cardPanel.getLayout().setActiveItem(wizRef.currentCard+1);
        }
	}
});