Ext.namespace('workflow');

workflow.SexSnpWizard = function(config) {
	Ext.apply(this, config,{});

	workflow.SexSnpWizard.superclass.constructor.call(this, Ext.apply({
		title: myLocale.lbCreateNewSnp,
		height: 245,
	
		previousButtonText: '&lt; ' + myLocale.lbBack,
		nextButtonText: myLocale.lbNext + ' &gt;',
		cancelButtonText: myLocale.lbCancel,
		finishButtonText: myLocale.lbFinish,
		onCancelClick: function(){
		Ext.Msg.confirm(myLocale.lbCancel, myLocale.lbConfirmCancel, function(btn, text){
	    	    if (btn == 'yes'){
	    	    	this.close();
	    	    }
	    	}, this);
		},
		headerConfig: {
			title: '<img src="./images/snpflow5s.png" />',
			stepText: '<br />' + myLocale.lbStepByStep
		},
		cards: [
		    new workflow.SexSnpFileUpload({wizRef: this, snpId: this.snpId}),
	        new workflow.SexSnpSelection({wizRef: this, snpId: this.snpId,
	        	onCardShow: function( card ){
	        	                        	  this.store.reload();
	        	                        	}})]
	}));
};

Ext.extend(workflow.SexSnpWizard, Ext.ux.Wiz, {

	snpId: null,

    onNextClick: function() {
    	this.cards[this.currentCard].commitCard(this.successNext);
    },

	successNext: function(wizRef) {
		if (wizRef.currentCard == wizRef.cardCount-1) {
			wizRef.onFinish();
        } else {
        	wizRef.cards[wizRef.currentCard+1].initWizCard();
        	wizRef.cardPanel.getLayout().setActiveItem(wizRef.currentCard+1);
        }
	}
});