Ext.namespace('workflow');

workflow.UserGrid = Ext.extend(Ext.grid.EditorGridPanel, {
    frame: true,
    height: 220,
    width: 435,
    autoScroll: true,
    style: 'margin-top: 10px',

    initComponent: function() {
        this.viewConfig = {
            forceFit: true
        };

        // relay the Store's CRUD events into this grid so these events can be conveniently listened-to in our application-code.
        this.relayEvents(this.store, ['destroy', 'save', 'update']);

        this.tbar = [{
            text: myLocale.lbAdd,
            iconCls: 'baddUser',
            handler: this.onAdd,
            scope: this
        }, '-', {
            text: myLocale.lbDelete,
            iconCls: 'bdelete',
            handler: this.onDelete,
            scope: this
        }];

        // super
        workflow.UserGrid.superclass.initComponent.call(this);
    },

    onAdd: function(btn, ev) {
        var u = new this.store.recordType({
            username : '',
            password: '',
            admin_value: ''
        });
        this.stopEditing();
        this.store.insert(0, u);
        this.startEditing(0, 1);
    },

    onDelete: function(btn, ev) {
        var index = this.getSelectionModel().getSelectedCell();
        if (!index) {
            return false;
        }
        var rec = this.store.getAt(index[0]);
        this.store.remove(rec);
    }
});