Ext.namespace('workflow');

workflow.UserManagement = function(config) {
	Ext.apply(this, config,{});

	var proxy = new Ext.data.HttpProxy({url:'./UserServlet'});

	var reader = new Ext.data.JsonReader({
	    successProperty: 'success',
	    idProperty: 'id',
	    root: 'data',
	    messageProperty: 'message'
	}, [
	    {name: 'id'},
	    {name: 'username', allowBlank: false},
	    {name: 'password', allowBlank: true},
	    {name: 'admin_value'}
	]);

	var store = new Ext.data.Store({
	    proxy: proxy,
	    reader: reader,
	    writer: new Ext.data.JsonWriter({writeAllFields:true}),
	    autoSave: true
	    
	});
	store.load();


	var combodata = new Ext.data.ArrayStore({
        data : [['1','Admin'],['0','Analyst'],['2','Lab']],
        fields: ['admin_id','admin_value'],
        sortInfo: {
            field: 'admin_value',
            direction: 'ASC'
        }
    });

	
	workflow.UserManagement.superclass.constructor.call(this, Ext.apply({
		//autoHeight: true,
		plain: true,
		modal: true,
		width: 450,
		height: 300,
		maximizable: false,
		resizable: false,
		closable: true,
		title: myLocale.lbUserManagement,
		buttonAlign: 'right',
		iconCls: 'icon-window-users',
		items: new workflow.UserGrid({
	        store: store,
	        clicksToEdit: 1,
	        cm: new Ext.grid.ColumnModel({
	        	columns: [
	                   {header: "ID", width: 10, sortable: false, dataIndex: 'id'},
	                   {header: myLocale.lbUsername, width: 50, sortable: true, dataIndex: 'username', editor: new Ext.form.TextField()},
	                   {header: "Password",
	               		dataIndex: 'password',
	            		width: 50,
	            		editor: new Ext.form.TextField({
	            			inputType: 'password',
	            			allowBlank: false}),
	            		renderer: function() {
	            			return '*****';
	            		}},
	            		{ header: 'Role',
	                    dataIndex: 'admin_value',
	                    width: 50,
	                  
                        value: 'Admin',
	                    editor: new Ext.form.ComboBox({
	                        store: combodata,
	                        dataIndex: 'admin_value',
	                        displayField:'admin_value',
	                        mode: 'local',
	                        editable: false,
	                        allowBlank: false,
	                        typeAhead: false,
	                        triggerAction: 'all',
	                        hideTrigger:false,
	                        lazyRender: true,
	                        emptyText: '',
	                        listeners:{
		                    	  change:function(combo, ewVal, oldVal) {
		                    	    console.log('hello');
		                    	  }
		                    	}
	                    
	                    })
	                   
	            		}
	            		
	               ]}),
	        listeners: {
	            rowclick: function(g, index, ev) {
	                var rec = g.store.getAt(index);
	            }
	        }
	    }),
		buttons: [{
			text: myLocale.lbOk,
			handler: function() {
				this.close();
			},
			scope: this
		}]
	}));
};

Ext.extend(workflow.UserManagement, Ext.Window, {});