Ext.namespace('workflow');

Ext.onReady(function(){
    Ext.QuickTips.init();

    workflow.login = new Ext.FormPanel({
    	height: 200,
        labelWidth: 90,
        url: './AuthenticationServlet',
        frame: false,
        border: false,
        defaultType: 'textfield',
        bodyStyle: 'padding: 0px 25px 0px 25px',
        monitorValid: true,
        buttonAlign: 'right',
        items:[{
        		xtype: 'box',
        		autoEl: {tag: 'img', src: './images/snpflow5l.png'}
        		

    		},{
                fieldLabel: myLocale.lbUsername,
                name: 'username',
                id: 'username',
                allowBlank: false,
                validateOnBlur: false,
                anchor: '80%',
                tabIndex: 1
            },{
                fieldLabel: myLocale.lbPassword,
                name: 'password',
                id: 'password',
                inputType: 'password',
                allowBlank: false,
                validateOnBlur: false,
                anchor: '80%',
                tabIndex: 2
            }],

        keys: [{
            key:13,
            scope: this,
            fn: function(key,e) {workflow.loginUser();}
        }],
        buttons:[{
                text: myLocale.lbLogin,
                formBind: true,
                cls: 'x-btn-text-icon login',
                handler: workflow.loginUser
            }]
    });

    workflow.win = new Ext.Window({
    	layout: 'fit',
    	title: 'v1.3.4',
        width: 370,
        autoHeight: true,
        closable: false,
        resizable: false,
        draggable: false,
        plain: true,
        border: false,
        items: workflow.login
	});
    workflow.win.show();

    var hideMask = function () {
        Ext.get('loading').remove();
        Ext.fly('loading-mask').fadeOut({
            remove: true
        });
        Ext.getCmp('username').focus('', 10);
    };
    hideMask.defer(250);
});

workflow.loginUser = function(){
	workflow.login.getForm().submit({
        method: 'POST',
        waitTitle: myLocale.lbLoginProcess,
        waitMsg: myLocale.lbPleaseWait,

        success: function(){
            var redirect = 'main.jsp';
            window.location = redirect;
        },

        failure: function(form, action){
            if(action.failureType == 'server'){
                obj = Ext.util.JSON.decode(action.response.responseText);
                Ext.Msg.alert(myLocale.lbLoginFailed, 'Given user/password is not allowed!!');
                Ext.getCmp('password').setValue('');
            }else{
                Ext.Msg.alert(myLocale.lbError, myLocale.lbUserNotPermitted);
            }
          //  login.getForm().reset();
        }
    }
	);
};