// reference local blank image
//Ext.BLANK_IMAGE_URL = '../lib/extjs2/resources/images/default/s.gif';

// init extjs bugfixes
Ext.Bugfixes.init();

Ext.QuickTips.init();

// create namespace
Ext.namespace('workflow');

Ext.onReady(function(){
	workflow.getUser();	
});

workflow.postInit = function() {
	var viewport = new workflow.Viewport();

	// delay viewport rendering to prevent rendering bug in ff3
	// remove when its not needed anymmore
	var delayedRendering = new Ext.util.DelayedTask(function() {
		viewport.syncSize();
		viewport.doLayout();
	});
	delayedRendering.delay(500);
	workflow.study.getStudies();

	var hideMask = function () {
        Ext.get('loading').remove();
        Ext.fly('loading-mask').fadeOut({
            remove:true
        });
    };
    hideMask.defer(250);
};

workflow.errorHandlingForm = function(form, action){
	Ext.Msg.show({
	   title: myLocale.lbError,
	   msg: action.response.responseText.message,
	   buttons: Ext.Msg.OK,
	   icon: Ext.MessageBox.ERROR
	});
};

workflow.errorHandlingAjax = function(result){
	workflow.LoadMask.hide();
	var obj = Ext.util.JSON.decode(result.responseText);
	Ext.Msg.show({
	   title: myLocale.lbError,
	   msg: obj.message,
	   buttons: Ext.Msg.OK,
	   icon: Ext.MessageBox.ERROR
	});
};

workflow.successHandlingAjax = function(result){
	workflow.LoadMask.hide();
	var obj = Ext.util.JSON.decode(result.responseText);
	Ext.Msg.show({
	   title: myLocale.lbSuccess,
	   msg: myLocale[obj.message],
	   buttons: Ext.Msg.OK,
	   icon: Ext.MessageBox.INFO
	});
};

workflow.user = [];

workflow.getUser = function (){
	//workflow.LoadMask.show();
	Ext.Ajax.request({
		url: './UserServlet',
		success: function(result) {
			var obj = Ext.util.JSON.decode(result.responseText);
			if (obj.admin==1){
				workflow.user.admin = true;
				workflow.user.lab = true;
			}
			else if (obj.admin==0){ // ANALYST
				 workflow.user.admin = false;
				 workflow.user.lab =false;
				}
			else{ // LAB
				 workflow.user.admin = false;
			     workflow.user.lab =true;
			}
			workflow.user.permissions = obj.permissions;
			workflow.postInit();
		},
		failure: workflow.errorHandlingAjax,
		params: { xaction: 'getUser'}
	});
};
