Ext.ns('workflow');

workflow.resultForm = function(config) {

	Ext.apply(this, config);

	workflow.resultForm.superclass.constructor.call(this, Ext.apply({
		title: myLocale.lbResults,
		layout: 'form',
 		autoScroll: true,
		bodyStyle: 'padding: 10px 10px 10px 10px;',
		items: new Ext.form.FormPanel({
			layout: 'form',
			frame: false,
			border: false,
			autoScroll: true,
			labelAlign: 'top',
			defaults: {
				labelWidth: 130
			},
			items: [{
				xtype: 'fieldset',
				title: myLocale.lbGeneral,
				layout: 'column',
				items: [{
					columnWidth: 0.5,
					layout: 'form',
					border: false,
					items: [{
						xtype: 'textfield',
						readOnly: true,
						fieldLabel: myLocale.lbNameSnp,
						width: 200,
						value: this.result.name
					}, {
						xtype: 'textfield',
						readOnly: true,
						fieldLabel: myLocale.lbDateSnp,
						width: 200,
						value: this.result.createdWhen
					}, {
						xtype: 'textfield',
						readOnly: true,
						fieldLabel: myLocale.lbCreator,
						width: 200,
						value: this.result.insertedBy
					}, {
						xtype: 'textarea',
						readOnly: true,
						fieldLabel: myLocale.lbComment,
						width: 200,
						value: this.result.comment
					}]
				}, {
					columnWidth: 0.5,
					layout: 'form',
					border: false,
					items: [{
						xtype: 'textfield',
						readOnly: true,
						fieldLabel: myLocale.lbSampleCount,
						width: 150,
						value: this.result.numSamples
					}, {
						xtype: 'textfield',
						fieldLabel: myLocale.lbQcSampleTotal,
						readOnly: true,
						width: 150,
						value: this.result.procQcSamples + " (" + this.result.numMultiple + ")"
					}, {
						xtype: 'textfield',
						fieldLabel: myLocale.lbCallrate,
						readOnly: true,
						width: 150,
						value: this.result.procCallRate
					}, {
						xtype: 'textfield',
						fieldLabel: myLocale.lbMaf,
						readOnly: true,
						width: 150,
						value: this.result.procMaf
						
					},  {
						xtype: 'textfield',
						id: 'sexsnpId',
						width: 150, 
						value: this.result,
						listeners: {
		                    'render': function(p) {
		                    	 
		                        if ([this.value.sex] >0){
		                           	this.value = this.value.sexsnp.length;
		                        	this.label.update(myLocale.lbSexSnpDiscordant);
		                        }
		                        else
		                        	{
		                        	this.hide();
		                        	}
		                    }
					}

						
					}]
				}]
			}, {
				xtype: 'fieldset',
				title: myLocale.lbQualityControl,
				layout: 'column',
				items: [{
					columnWidth: 0.3,
					layout: 'form',
					border: false,
					items: [{
						xtype: 'textfield',
						fieldLabel: myLocale.lbDiscordanceRate,
						width: 150,
						readOnly: true,
						value: this.result.procDiscRate
					}]
				}, {
					columnWidth: 0.3,
					layout: 'form',
					border: false,
					items: [{
						xtype: 'textfield',
						fieldLabel: myLocale.lbDiscordance,
						width: 150,
						readOnly: true,
						value: this.result.numDisc
					}]
				}, {
					columnWidth: 0.3,
					layout: 'form',
					border: false,
					items: [{
						xtype: 'textfield',
						fieldLabel: myLocale.lbQcSamplesCalled,
						width: 150,
						readOnly: true,
						value: this.result.procQc + "% (" + Math.round(this.result.numSamples * this.result.procQc / 100) + ")"
					}]
				}]
			}, {
				xtype: 'fieldset',
				title: myLocale.lbHwe,
				layout: 'column',
				items: [{
					columnWidth: 0.4,
					layout: 'form',
					bodyStyle: 'padding:0 18px 0 0',
					border: false,
					items: [{
						xtype: 'fieldset',
						title: myLocale.lbObserved,
						layout: 'form',
						items: [{
							layout: 'form',
							border: false,
							items: [{
								xtype: 'textfield',
								fieldLabel: this.result.nameHomo1,
								width: 100,
								readOnly: true,
								value: this.result.hwe.homoObserved1
							}, {
								xtype: 'textfield',
								fieldLabel: this.result.nameHetero,
								width: 100,
								readOnly: true,
								value: this.result.hwe.heteroObserved
							}, {
								xtype: 'textfield',
								fieldLabel: this.result.nameHomo2,
								width: 100,
								readOnly: true,
								value: this.result.hwe.homoObserved2
							}]
						}]
					}, {
						xtype: 'textfield',
						fieldLabel: myLocale.lbHweTest,
						width: 150,
						readOnly: true,
						value: this.result.hwe.chiSquare
					}/*, {
						xtype: 'textfield',
						fieldLabel: 'Fisher Exact',
						width: 150,
						value: this.result.hwe.exact
					}*/]
				}, {
					columnWidth: 0.4,
					layout: 'form',
					bodyStyle: 'padding:0 18px 0 0',
					border: false,
					items: [{
						xtype: 'fieldset',
						title: myLocale.lbExpected,
						layout: 'form',
						items: [{
							layout: 'form',
							border: false,
							items: [{
								xtype: 'textfield',
								fieldLabel: this.result.nameHomo1,
								width: 100,
								readOnly: true,
								value: this.result.hwe.homoExpected1
							}, {
								xtype: 'textfield',
								fieldLabel: this.result.nameHetero,
								width: 100,
								readOnly: true,
								value: this.result.hwe.heteroExpected
							}, {
								xtype: 'textfield',
								fieldLabel: this.result.nameHomo2,
								width: 100,
								readOnly: true,
								value: this.result.hwe.homoExpected2
							}]
						}]
					}]
				}]
			}]
		})
	}));
};

Ext.extend(workflow.resultForm, Ext.Panel, {
	result: null
});