Ext.ns('workflow');

workflow.resultHapMap = function(config) {

	Ext.apply(this, config, {
		result: null
	});

	this.reader = new Ext.data.ArrayReader({}, [
        {name: 'population', type: 'string'},
        {name: 'homo1', type: 'float'},
        {name: 'homoFreq1'},
        {name: 'homo2', type: 'float'},
        {name: 'homoFreq2'},
        {name: 'hetero', type: 'float'},
        {name: 'heteroFreq'},
        {name: 'total', type: 'int'},
        {name: 'chi', type: 'string'}
     ]);

 	this.store = new Ext.data.Store({
         reader: this.reader,
         data: this.result.hapmaps
    });

 	workflow.resultOptional.superclass.constructor.call(this, Ext.apply({
 		title: 'HapMap (R27) / 1000GENOMES comparison',
 		layout: 'fit',
 		autoScroll: true,
     	items: [new Ext.grid.GridPanel({
     		autoHeight: true,
 		    autoScroll: true,
 	        store: this.store,
 	        viewConfig: {
     			deferEmptyText: false,
 	            forceFit: true,
 	            emptyText: myLocale.lbCouldNotGetHapMap
 	        },
 	        columns: [
                {id: 'population', header: myLocale.lbPopulation, menuDisabled: true, width: 150, sortable: false, dataIndex: 'population'},
                {header: this.result.nameHomo1 + myLocale.lbHapMapDescritpion, width: 150, menuDisabled: true, sortable: false, dataIndex: 'homo1', renderer: function(v, p, r){return r.data.homoFreq1 + ' | ' + r.data.homo1;}},
                {header: this.result.nameHetero+ myLocale.lbHapMapDescritpion, width: 150, sortable: false, menuDisabled: true, dataIndex: 'hetero', renderer: function(v, p, r){return r.data.heteroFreq + ' | ' + r.data.hetero;}},
                {header: this.result.nameHomo2+ myLocale.lbHapMapDescritpion, width: 100, sortable: false, menuDisabled: true, dataIndex: 'homo2', renderer: function(v, p, r){return r.data.homoFreq2 + ' | ' + r.data.homo2;}},
                {header: myLocale.lbNTotal, width: 100, sortable: false, menuDisabled: true, dataIndex: 'total'},
                {header: myLocale.lbPValue, width: 100, sortable: false, menuDisabled: true, dataIndex: 'chi', renderer: function(v, p, r){if (r.data.chi ==-1) return 'undefined'; else return r.data.chi;}}
            ]
     	}), new Ext.Panel({
     		autoHeight: true,
     		collapsible: true,
     		border: false,
     		frame: false,
            title: 'Population descriptors',
            html: '<font face="Verdana" size="3" color="green"><div><b>HapMap (R27)<br/>' 
            	+ '<font face="Verdana" size="2" color="grey"><div><b>ASW (A): </b>African ancestry in Southwest USA<br/>'
     			+'<b>CEU (C): </b>Utah residents with Northern and Western European ancestry from the CEPH collection<br/>'
     			+'<b>CHB (H): </b>Han Chinese in Beijing, China<br/>'
     			+'<b>CHD (D): </b>Chinese in Metropolitan Denver, Colorado<br/>'
     			+'<b>GIH (G): </b>Gujarati Indians in Houston, Texas<br/>'
     			+'<b>JPT (J): </b>Japanese in Tokyo, Japan<br/>'
     			+'<b>LWK (L): </b>Luhya in Webuye, Kenya<br/>'
     			+'<b>MEX (M): </b>Mexican ancestry in Los Angeles, California<br/>'
     			+'<b>MKK (K): </b>Maasai in Kinyawa, Kenya<br/>'
     			+'<b>TSI (T): </b>Tuscan in Italy<br/>'
     			+'<b>YRI (Y): </b>Yoruban in Ibadan, Nigeria'
     			+'<p><br><font face="Verdana" size="3" color="green"><div><b>1000GENOMES<br/></font></p>'
     			+'<b>AFR: </b>African = YRI + LWK + GWD + MSL + ESN + ASW<br/>'
     			+'<b>AMR: </b>Ad Mixed American = MXL + PUR + CLM + PEL <br/>'
     			+'<b>ASN: </b>East Asian = JPT + CHS + CDX + KHV <br/>'
     			+'<b>EUR: </b>European = CEU + TSI + FIN + GBR + IBS<br/>'
     			+'<br /><br />For G/C and A/T polymorphisms, whose strand orientation cannot be determined by the nucleotides itself, the genotype designations used in SNPflow must correspond to the strand orientation of the HapMap / 1000GENOMES genotypes.'
     			+'</div></font>'
        })]
     }));
};

Ext.extend(workflow.resultHapMap, Ext.Panel, {});