Ext.ns('workflow');

workflow.resultOptional = function(config) {

	Ext.apply(this, config, {
		data: null
	});

	this.reader = new Ext.data.ArrayReader({}, [
       {name: 'sampleId'},
       {name: 'callName'},
       {name: 'well'},
       {name: 'fileName'},
       {name: 'discordant'},
       {name: 'counter'}
       
    ]);

	this.store = new Ext.data.GroupingStore({
        reader: this.reader,
        data: this.data,
        sortInfo: {field: 'sampleId', direction: "ASC"},
        groupField: 'discordant'
    });

	workflow.resultOptional.superclass.constructor.call(this, Ext.apply({
		title: myLocale.lbDiscordantReplicates,
 		autoScroll: true,
    	items: new Ext.grid.GridPanel({
    		autoHeight: true,
		    autoScroll: true,
	        store: this.store,
	        columns: [
               {id: 'sampleId', header: myLocale.lbSampleId, menuDisabled: true, width: 150, sortable: false, dataIndex: 'sampleId'},
               {header: myLocale.lbGenotype, width: 150, menuDisabled: true, sortable: false, dataIndex: 'callName'},
               {header: myLocale.lbWell, width: 150, sortable: false, menuDisabled: true, dataIndex: 'well'},
               {header: myLocale.lbFilename, width: 100, sortable: false, menuDisabled: true, dataIndex: 'fileName'},
               {header: "", width: 100, hidden: true, sortable: false, menuDisabled: true, dataIndex: 'discordant'},
               {header: "", width: 100, hidden: true, sortable: false, menuDisabled: true, dataIndex: 'counter'}
           ],
           view: new Ext.grid.GroupingView({
               forceFit: true,
               emptyText: myLocale.lbNoSamples,
               groupTextTpl: '{[ values.rs[0].data["discordant"] ? "' +myLocale.lbMultiples + '" : "' + myLocale.lbDiscordantSamples + '" ]} ( {[values.rs[0].data["counter"]]} {[values.rs.length > 1 ? "Samples" : "Sample"]})'
           })
    	})
    }));
};

Ext.extend(workflow.resultOptional, Ext.Panel, {});