Ext.ns('workflow');

workflow.resultSexSnp = function(config) {

	Ext.apply(this, config, {
		data: null
	});

	this.reader = new Ext.data.ArrayReader({}, [
       {name: 'sampleId'},
       {name: 'genotype'},
       {name: 'phenotype'}
       
    ]);

	this.store = new Ext.data.GroupingStore({
        reader: this.reader,
        data: this.data,
        sortInfo: {field: 'sampleId', direction: "ASC"},
        groupField: 'genotype'
    });

	workflow.resultSexSnp.superclass.constructor.call(this, Ext.apply({
		title: myLocale.lbSexSnpDiscordant,
 		autoScroll: true,
 		
    	items: new Ext.grid.GridPanel({
    		id: 'idGrid',
    		autoHeight: true,
		    autoScroll: true,
	        store: this.store,
	        columns: [
               {id: 'sampleId', header: myLocale.lbSampleId, menuDisabled: true, width: 150, sortable: false, dataIndex: 'sampleId'},
               {header: myLocale.lbPhenotype, width: 150, sortable: false, menuDisabled: true, dataIndex: 'phenotype'},
               {header: myLocale.lbGenotype, width: 150, menuDisabled: true, sortable: false, dataIndex: 'genotype'}
               
           ],

           view: new Ext.grid.GroupingView({
               forceFit: true,
               emptyText: myLocale.lbNoSamples,
               groupTextTpl: myLocale.lbSexSnpDiscordant +' ('+ this.store.getCount()+'  Samples)'
           })
    	})
    }));
};

Ext.extend(workflow.resultSexSnp, Ext.Panel, {});