Ext.ns('workflow.study');

workflow.study.addSamples = function(studyId){
	var win = new Ext.Window({
		title: myLocale.lbImportSamples,
		width: 500,
		autoheight: true,
		modal: true,
		closable: true
	});

	var fp = new Ext.FormPanel({
        width: 500,
        frame: true,
		autoheight: true,
		resizable: false,
        bodyStyle: 'padding: 10px 10px 10px 10px;',
        labelWidth: 120,
        fileUpload: true,
        defaults: {
            anchor: '95%',
            msgTarget: 'side'
        },
        items: [{
            xtype: 'textfield',
			id: 'requestType',
			name: 'requestType',
			value: '',
			hideLabel: true,
			hidden: true
        },{
            xtype: 'textfield',
			id: 'study.id',
			name: 'study.id',
			value: studyId,
			hideLabel: true,
			hidden: true
        },{
            xtype: 'fileuploadfield',
            id: 'sampleFile',
            emptyText: myLocale.lbChooseSamplefile,
            fieldLabel: myLocale.lbSamplefile + ' <br><a href="http://www3.i-med.ac.at/genepi-snpflow/userguide.html" target="_blank">'+myLocale.lbUserManual+'</a>',
            name: 'sampleFile',
            tabIndex: 1,
            buttonCfg: {
                text: '',
                iconCls: 'upload-icon'
            }
        }],
        buttons: [{
        	cls: 'x-btn-text-icon importbtn',
            text: myLocale.lbImport,
            handler: function(){
                if(fp.getForm().isValid()){
	                fp.getForm().submit({
	                	url: './AddSampleServlet',
	                    waitTitle: myLocale.lbStoreProgress,
	                    waitMsg: myLocale.lbPleaseWait,
	                    success: function(fp, o){
	                        Ext.MessageBox.alert(myLocale.lbSuccess,myLocale.lbSuccessfullyImportSamplefile);
	                        win.close();
	                    },
						failure: function(fp, o){
						  Ext.MessageBox.alert(myLocale.lbError,myLocale.lbServersideErrorWrongSampleFile +  '<br>' + ' <a href="http://www3.i-med.ac.at/genepi-snpflow/userguide.html" target="_blank">'+myLocale.lbUserManual+'</a>');
						}
	                });
                }
            }
        },{
        	cls: 'x-btn-text-icon bcancel',
            text: myLocale.lbCancel,
            handler: function(){
                win.close();
            }
        }]
    });

	win.add(fp);
	win.show();
	Ext.getCmp('sampleFile').focus('', 10);
};

workflow.study.edit = function(study){
	var win = new Ext.Window({
		title: myLocale.lbEditStudy,
		width: 400,
		autoheight: true,
		modal: true,
		closable: true
	});

	var fp = new Ext.FormPanel({
        width: 400,
        frame: true,
		autoheight: true,
		resizable: false,
        bodyStyle: 'padding: 10px 10px 0 10px;',
        labelWidth: 150,
        defaults: {
            anchor: '95%',
            msgTarget: 'side'
        },
        items: [{
            xtype: 'textfield',
			name: 'study.name',
			id: 'study.name',
			value: study.name,
            fieldLabel: myLocale.lbStudyName,
            allowBlank: false,
            tabIndex: 1
        },{
            xtype: 'textfield',
			name: 'study.identifier',
			value: study.identifier,
            fieldLabel: myLocale.lbIdentification,
            tabIndex: 2
        }, new Ext.ux.form.SpinnerField({
            fieldLabel: myLocale.lbMultiplies,
            tabIndex: 3,
            allowBlank: false,
            name: 'study.numMultiple',
            value: study.numMultiple
        }), {
            xtype: 'textfield',
			name: 'study.description',
			value: study.description,
            fieldLabel: myLocale.lbDescription,
            tabIndex: 4
        }, {
            xtype: 'textfield',
			name: 'requestType',
			value: 'editStudy',
			hideLabel: true,
			hidden: true
        }, {
            xtype: 'textfield',
			name: 'id',
			value: study.id,
			hideLabel: true,
			hidden: true
        }
		],
        buttons: [{
        	cls: 'x-btn-text-icon bsave',
            text: myLocale.lbStore,
            handler: function(){
                if(fp.getForm().isValid()){
	                fp.getForm().submit({
	                	url: './WorkflowServlet',
	                    waitTitle: myLocale.lbStoreProgress,
	                    waitMsg: myLocale.lbPleaseWait,
	                    success: function(fp, o){
	                        Ext.MessageBox.alert(myLocale.lbSuccess,myLocale.lbSuccessfullySavedStudy);
	                        win.close();
	                        workflow.study.getStudies();
	                    },
						failure: function(fp, o){
							  Ext.MessageBox.alert(myLocale.lbError,myLocale.lbServersideErrorWrongSampleFile  +  '<br>' + ' <a href="http://www3.i-med.ac.at/genepi-snpflow/userguide.html target="_blank"">'+myLocale.lbUserManual+'</a>');
									}
	                });
                }
            }
        },{
        	cls: 'x-btn-text-icon bcancel',
            text: myLocale.lbCancel,
            handler: function(){
                win.close();
            }
        }]
    });

	win.add(fp);
	win.show();
	Ext.getCmp('study.name').focus('', 10);
};

var contextmenucreate = function(node, e) {
	
	var siblings = Ext.getCmp('west-panel').getSelectionModel().getSelectedNodes();
	var snpId = "";
	var treeMenu = new Ext.menu.Menu({
        items: [
            new Ext.menu.Item({
            	icon: './images/export.png',
                text: myLocale.lbExport + '...',
                tooltip: myLocale.lbSnpExport,
                handler: function(){
            	
                    //---- LF-2012-06-19
                    var sameStudy = true;
                    var studyId = -1;
                    
                    for (var i=0; i<siblings.length; i++){
        	
                	if (siblings[i].id.indexOf("snp")!=-1){
                
                	    if (studyId == -1){
                		
                		studyId = siblings[i].attributes.study_id;
                		
                	    }else{
                		
                		sameStudy = (sameStudy && (studyId == siblings[i].attributes.study_id));
                	    }

                    	}

                    }
                    
                    if(!sameStudy){

                	Ext.Msg.alert('Attention','Only SNPs from the same study can be exported together.' );
                	return;
                	
                    }
                    
                    //----- LF-2012-06-19
                    
                	for (var i=0; i<siblings.length; i++){
                		try{
                       if (siblings[i].id.indexOf("snp")!=-1)
                			snpId = snpId + " "+ siblings[i].id.split("_")[1];
                      
                		}catch(err){
                			Ext.Msg.alert('Attention','Please select SNPs only!' );
                		}
                		}
                	if (snpId.trim().length==0){
                		node.select();
                		snpName =node.text;
                		snpId = node.id.split("_"[1]);
                		}
                 	console.log(snpId);
                 	var win = new workflow.ExportSnp({
            			snpId: snpId,
            			multi: node.id
            		});
              		win.show();
            		win.center();
            	}
            }), 
            new Ext.menu.Item({
            	icon: './images/users.png',
                text: myLocale.lbSexSnp,
                tooltip: myLocale.lbSexSnp,
                disabled: !(workflow.user.admin || workflow.user.lab),
                handler: function(){
                	
                		
                		node.select();
                		var siblings = Ext.getCmp('west-panel').getSelectionModel().getSelectedNodes();
                		snpName =node.text;
                		var snpid= siblings[0];
                		
                		snpId = snpid.toString().split("_"[1]);
                		
                	
                	var win = new workflow.SexSnpWizard({
            			snpId: snpId
            		});
              		win.show();
            		win.center();
            		
            		
                	//Ext.getCmp('west-panel').getSelectionModel().select(Ext.getCmp('west-panel').getNodeById(), null, true);
               	}
            }), 
            
            
            
            '-',  new Ext.menu.Item({
            	text: myLocale.lbDelete,
            	icon: './images/delete.png',
            	disabled: !workflow.user.admin && ! workflow.user.lab,
            	handler: function(){

            		 var snpName = "";

            		for (var i=0; i<siblings.length; i++){
            			try{
                    	snpName = snpName + " <br>"+ siblings[i].text;
                    	snpId= snpId+ " " + siblings[i].id.split("_")[1];
            			}catch(err){
                			Ext.Msg.alert('Attention','Please select SNPs only!' );
                		}
            		}
            		if (snpId.trim().length==0){
                		node.select();
                		snpName =node.text;
                		snpId = node.id.split("_"[1]);
                		}
            		
                	Ext.Msg.confirm(myLocale.lbConfirmDelete, myLocale.lbReallyDeleteSnp + "<br>"+snpName.trim(), function(btn, text){
	            	    if (btn == 'yes'){
	            	    	workflow.LoadMask.show();
	            	    	Ext.Ajax.request({
	            	    		url: './SNPDataServlet',
	            	    		success: function(response){
	            	    		
	            	    			node = siblings[0].parentNode;
	            	    	
	            	    			for (var i=0; i<siblings.length; i++){
	            	    			node.parentNode.removeChild(siblings[i]);
	            	    			}
	            	    			workflow.successHandlingAjax(response);
	            	    		},
	            	    		failure: function(response) {
	            	    			workflow.LoadMask.hide();
	            	    			Ext.Msg.alert('Attention','Error during deletion!' );
	            	    		},
	            	    		params: { requestType: 'deleteSNP', snpId: snpId , multi: 'null'}
	            	    	});
	            	    }
	            	});
            	
            		}
        	})
        ]
    });
	treeMenu.showAt(e.getXY());
};


var contextmenucreateAll = function(node, e) {
	var children = node.childNodes;
	Ext.getCmp('west-panel').expandPath(node.getPath());
	var treeMenu = new Ext.menu.Menu({
        items: [
            new Ext.menu.Item({
            	icon: './images/export.png',
                text: myLocale.lbExportAll+'...',
                tooltip: myLocale.lbSnpExport,
                handler: function(){
                	for (var i=0; i<children.length; i++){
                		var id = children[i].id;
                	//	if (i==0)  //avoid that the parent node remains selected
                	//	Ext.getCmp('west-panel').getSelectionModel().select(Ext.getCmp('west-panel').getNodeById(id));
                	//		else
                		Ext.getCmp('west-panel').getSelectionModel().select(Ext.getCmp('west-panel').getNodeById(id), null, true);
                	}
                	Ext.getCmp('west-panel').getSelectionModel().select(Ext.getCmp('west-panel').getNodeById(id), null, true);
               	}
            }), 
            '-',  
            new Ext.menu.Item({
            	text: myLocale.lbDeleteAll,
            	icon: './images/delete.png',
            	disabled: !workflow.user.admin && ! workflow.user.lab,
            	handler: function(){
            		var children = node.childNodes;
            		var snpId="";
            		
                	for (var i=0; i<children.length; i++){
                	
                	snpId = snpId + " "+ children[i].id.split("_")[1];
                	}
                	Ext.Msg.confirm(myLocale.lbConfirmDelete, myLocale.lbReallyDeleteSnp,  function(btn, text){
	            	    if (btn == 'yes'){
	            	    	workflow.LoadMask.show();
	            	    	Ext.Ajax.request({
	            	    		url: './SNPDataServlet',
	            	    		success: function(response){
	            	    			node.parentNode.removeChild(node);
	            	    			workflow.successHandlingAjax(response);
	            	    		},
	            	    		failure: function(response) {
	            	    			workflow.LoadMask.hide();
	            	    		},
	            	    		params: { requestType: 'deleteSNP', snpId: snpId, multi: node.id }
	            	    	});
	            	    }
	            	});
            	}
        	})
        ]
    });
	treeMenu.showAt(e.getXY());
};


workflow.study.create = function(){
	var win = new Ext.Window({
		title: myLocale.lbCreateStudy,
		width: 400,
		autoheight: true,
		modal: true,
		closable: true
	});

	var fp = new Ext.FormPanel({
        width: 400,
        frame: true,
		autoheight: true,
		resizable: false,
        bodyStyle: 'padding: 10px 10px 0 10px;',
        labelWidth: 150,
        fileUpload: true,
        defaults: {
            anchor: '95%',
            msgTarget: 'side'
        },
        items: [{
            xtype: 'textfield',
            id: 'study.name',
			name: 'study.name',
            fieldLabel: myLocale.lbStudyName,
            allowBlank: false,
            tabIndex: 1
        },{
            xtype: 'textfield',
			name: 'study.identifier',
            fieldLabel: myLocale.lbIdentification,
            tabIndex: 2
        }, new Ext.ux.form.SpinnerField({
            fieldLabel: myLocale.lbMultiplies,
            tabIndex: 3,
            id: 'study.numMultiple',
            name: 'study.numMultiple'
        }), {
            xtype: 'textfield',
			name: 'study.description',
            fieldLabel: myLocale.lbDescription,
            tabIndex: 4
        },{
            xtype: 'fileuploadfield',
            emptyText: myLocale.lbChooseSamplefile,
            allowBlank: false,
            fieldLabel: myLocale.lbSamplefile,
            name: 'sampleFile',
            buttonCfg: {
                text: '',
                iconCls: 'upload-icon'
            }
        },{
            xtype : 'box',
            style: 'padding-top: 20px',
            html : myLocale.lbUserManual

        }, {
            xtype: 'textfield',
			id: 'requestType',
			name: 'requestType',
			value: 'insertStudy',
			hideLabel: true,
			hidden: true
        }],
        buttons: [{
        	cls: 'x-btn-text-icon bsave',
            text: myLocale.lbStore,
            handler: function(){
                if(fp.getForm().isValid()){
	                fp.getForm().submit({
	                	url: './WorkflowServlet',
	                    waitTitle: myLocale.lbStoreProgress,
	                    waitMsg: myLocale.lbPleaseWait,
	                    success: function(fp, o){
	                        Ext.MessageBox.alert(myLocale.lbSuccess,myLocale.lbSuccessfullyCreatedStudy);
	                        win.close();
	                        workflow.study.getStudies();
	                    },
						failure: function(fp, o){
							  Ext.MessageBox.alert(myLocale.lbError,o.response.responseText.split("Exception:")[1].split("\"")[0] + '<br><br>' );
									}
	                });
                }
            }
        },{
        	cls: 'x-btn-text-icon bcancel',
            text: myLocale.lbCancel,
            handler: function(){
                win.close();
            }
        }]
    });

	win.add(fp);
	win.show();
	Ext.getCmp('study.name').focus('', 10);
};

workflow.study.createMin = function(){
	var win = new Ext.Window({
		title: myLocale.lbCreateStudy,
		width: 400,
		autoheight: true,
		modal: true,
		closable: true
	});

	var fp = new Ext.FormPanel({
        width: 400,
        frame: true,
		autoheight: true,
		resizable: false,
        bodyStyle: 'padding: 10px 10px 0 10px;',
        labelWidth: 120,
        defaults: {
            anchor: '95%',
            msgTarget: 'side'
        },
        items: [{
            xtype: 'textfield',
            id: 'study.name',
			name: 'study.name',
            fieldLabel: myLocale.lbStudyName,
            allowBlank: false,
            tabIndex: 1
        },{
            xtype: 'textfield',
            id: 'study.identifier',
			name: 'study.identifier',
            fieldLabel: myLocale.lbIdentification,
            tabIndex: 2
        },{
            xtype: 'textfield',
			name: 'study.description',
            fieldLabel: myLocale.lbDescription,
            tabIndex: 3
        }, {
            xtype: 'textfield',
			id: 'requestType',
			name: 'requestType',
			value: 'insertStudyMin',
			hideLabel: true,
			hidden: true
        }
		],
        buttons: [{
        	cls: 'x-btn-text-icon bsave',
            text: myLocale.lbStore,
            handler: function(){
                if(fp.getForm().isValid()){
	                fp.getForm().submit({
	                	url: './WorkflowServlet',
	                    waitTitle: myLocale.lbStoreProgress,
	                    waitMsg: myLocale.lbPleaseWait,
	                    success: function(fp, o){
	                        Ext.MessageBox.alert(myLocale.lbSuccess,myLocale.lbCreateStudySuccess);
	                        win.close();
	                        workflow.study.getStudies();
	                    },
						failure: function(fp, o){
						  Ext.MessageBox.alert(myLocale.lbError,myLocale.lbServersideError);
						}
	                });
                }
            }
        },{
        	cls: 'x-btn-text-icon bcancel',
            text: myLocale.lbCancel,
            handler: function(){
                win.close();
            }
        }]
    });

	win.add(fp);
	win.show();
	Ext.getCmp('study.name').focus('', 10);
};

workflow.study.getStudies = function (snpId){
	workflow.LoadMask.show();
	Ext.Ajax.request({
		url: './WorkflowServlet',
		success: function(result) {
			workflow.study.fillStudyTree(result, snpId);
		},
		failure: workflow.errorHandlingAjax,
		timeout: 240000,
		params: { requestType: 'getAllStudies' }
	});
};

workflow.study.fillStudyTree = function (result, snpId){
	workflow.LoadMask.hide();
	var jsonObj = Ext.util.JSON.decode(result.responseText);
	var studyList = jsonObj.data;
	var deactivatedList = [];

	var tree = Ext.getCmp('west-panel');
    var rootNode = tree.getRootNode();

    // clear tree
    while(rootNode.firstChild) {
    	rootNode.removeChild(rootNode.firstChild);
    }

	for(var i=0;i<studyList.length;++i){
		var study = studyList[i];
		var isActive = study.active;

		if(isActive) {
			var studyNode = new Ext.tree.TreeNode({
				id: study.id,
				name: 'show',
				studyId: study.id,
		        text: study.name + ' ' + study.identifier,
		        qtip: study.description,
		        expandable: true,
		        icon: './images/folder2.png',
		        style: 'padding: 2px',
		        listeners: {
			        contextmenu: function(node, e) {
	        			var studyId = node.id;
			        	var treeMenu = new Ext.menu.Menu({
			                items: [new Ext.menu.Item({
				    	        	name: 'generate-QC',
				    	        	text: myLocale.lbEditSelectedStudy + '...',
				    	        	icon: './images/edit.png',
				    	        	disabled: !(workflow.user.admin || workflow.user.lab),
				    	        	handler: function() {
			                			workflow.editStudy(studyId);
			                		}
			    	        	}), new Ext.menu.Item({
			        	        	name: 'add-samples',
			        	            text: myLocale.lbImportSamples + '...',
			        	            icon: './images/samples.png',
			        	            disabled: !workflow.user.admin,
			        	            hidden: true,
			        	            handler: function(){
	                					workflow.study.addSamples(studyId);
	                				}
				                }), '-', new Ext.menu.Item({
				    	        	name: 'generate-QC',
				    	        	text: myLocale.lbCreateSnp + '...',
				    	        	icon: './images/calculation.png',
				    	        	disabled: !workflow.user.admin && !workflow.user.lab,
				    	        	handler: function(){
				    	            	var win = new workflow.ImportWizard({
				    	            		studyId: studyId
				    	            	});
				    	        		win.show();
				    	        		win.center();
				    	        	}
				    	        }),'-',
				                new Ext.menu.Item({
				                	cls: 'bdeactivate', // icon and text class
				                    text: myLocale.lbDeactivateStudy,
				                    tooltip: myLocale.lbDeactivateStudy,
				                    disabled: !workflow.user.admin,
				                    handler: function(){
				                	Ext.Msg.confirm(myLocale.lbConfirm, myLocale.lbReallyDeactivateStudy, function(btn, text){
				            	        if (btn == 'yes'){
				            	          workflow.LoadMask.show();
				            	          Ext.Ajax.request({
				            	            url: './WorkflowServlet',
				            	            success: function(response){
				            	              workflow.study.getStudies();
				            	              workflow.successHandlingAjax(response);
				            	            },
				            	            failure: function(response) {
				            	              workflow.LoadMask.hide();
				            	            },
				            	            params: { requestType: 'deactivateStudy', studyId: studyId }
				            	          });
				            	        }
				            	    });
				                	}
				                })
			                ]
			            });
		        		treeMenu.showAt(e.getXY());
			        }
		        }
		    });
			studyNode.appendChild(new Ext.tree.TreeNode({
				name: 'show',
				text: myLocale.lbShowSamples,
				icon: './images/vcard.png',
			    leaf: false,
				listeners: {
					dblclick: function(node, e) { dbClickHandler(node.parentNode, 0); }
		        }
			}));
			
			var multiNode ;
			for (var j=0, l=study.snps.length; j<l ;++j) {
				
				var snp = study.snps[j];
				if (snp.directory!=""){
					var folder = studyNode.findChild('id', snp.directory);
					if (folder==null)
						{					
						multiNode =  new Ext.tree.TreeNode({
						id: snp.directory,
						text: snp.directory,
						icon: './images/folder5.png',
					    leaf: false,
						listeners: 
							{
								dblclick: function(node, e) {
									var nodeid = node.id.split("_")[1];
									dbClickHandler(node, nodeid);
								},
								contextmenu: contextmenucreateAll
							}
				        
				        
				        
					});
						multiNode.appendChild(
								new Ext.tree.TreeNode({
								id: "snp_" + snp.id,
								name: 'snp',
								study_id: snp.study,
								text: snp.name,
							    leaf: true,
							    icon: './images/tag_blue.png',
								listeners: {
									dblclick: function(node, e) {
										var nodeid = node.id.split("_")[1];
										dbClickHandler(node, nodeid);
									}, 
									contextmenu: contextmenucreate
						        }
							}
					));
						studyNode.appendChild(multiNode);
				}else{
				
					folder.appendChild(
							new Ext.tree.TreeNode({
							id: "snp_" + snp.id,
							name: 'snp',
							study_id: snp.study,
							text: snp.name,
						    leaf: true,
						    icon: './images/tag_blue.png',
							listeners: {
								dblclick: function(node, e) {
									var nodeid = node.id.split("_")[1];
									dbClickHandler(node, nodeid);
								},
								contextmenu: contextmenucreate
					        }
						}
				));
				}
					
					}
				else
					if (snp.sex==0){
						
				studyNode.appendChild(
						new Ext.tree.TreeNode({
					id: "snp_" + snp.id,
					name: 'snp',
					text: snp.name,
					study_id: snp.study,
				    leaf: true,
				    icon: './images/tag_blue.png',
					listeners: {
						dblclick: function(node, e) {
							var nodeid = node.id.split("_")[1];
							dbClickHandler(node, nodeid);
						},
						contextmenu:  contextmenucreate
			        }
				}));
				}
					else{
						studyNode.appendChild(
								new Ext.tree.TreeNode({
							id: "snp_" + snp.id,
							name: 'snp',
							text: snp.name + ' (Sex-SNP)',
							study_id: snp.study,
						    leaf: true,
						    icon: './images/tag_green.png',
							listeners: {
								dblclick: function(node, e) {
									var nodeid = node.id.split("_")[1];
									dbClickHandler(node, nodeid);
								},
								contextmenu:  contextmenucreate
					        }
						}));}
			}
			
			rootNode.appendChild(studyNode);
		} else {
			deactivatedList.push(study);
		}
	}

	if (deactivatedList.length > 0) {
		var deactivatedStudies = new Ext.tree.TreeNode({
	        text: myLocale.lbDeactivatedStudies,
	        qtip: myLocale.lbCouldActivateStudies,
	        expandable: true,
	        icon: './images/deactivate.png'
	    });

		for(var i=0, l=deactivatedList.length;i<l;++i){
			var st = deactivatedList[i];
			deactivatedStudies.appendChild(new Ext.tree.TreeNode({
				id: st.id,
				name: 'inactive',
				text: st.name + st.identifier,
		        qtip: st.description,
				icon: './images/folder5.png',
			    leaf: true,
			    listeners: {
			        contextmenu: function(node, e) {
	        			var studyId = node.id;
			        	var treeMenu = new Ext.menu.Menu({
			                items: [new Ext.menu.Item({
				                	cls: 'bactivate',
				                    text: myLocale.lbActivateStudy,
				                    tooltip: myLocale.lbActivateStudy,
				                    disabled: !workflow.user.admin,
				                    handler: function(){
					                	Ext.Msg.confirm(myLocale.lbConfirm, myLocale.lbReallyActivateStudy, function(btn, text){
					            	        if (btn == 'yes'){
					            	          workflow.LoadMask.show();
					            	          Ext.Ajax.request({
					            	            url: './WorkflowServlet',
					            	            success: function(response){
					            	              workflow.study.getStudies();
					            	              workflow.successHandlingAjax(response);
					            	            },
					            	            failure: function(response) {
					            	              workflow.LoadMask.hide();
					            	            },
					            	            params: { requestType: 'activateStudy', studyId: studyId }
					            	          });
					            	        }
					            	    });
				                	}
				                })
			                , 
			                new Ext.menu.Item({
			                	cls: 'bdelete',
			                    text: myLocale.lbDeleteStudy,
			                    tooltip: myLocale.lbDeleteStudy,
			                    disabled: !workflow.user.admin,
			                    handler: function(){
				                	Ext.Msg.confirm(myLocale.lbConfirm, myLocale.lbReallyDeleteStudy, function(btn, text){
				            	        if (btn == 'yes'){
				            	          workflow.LoadMask.show();
				            	          Ext.Ajax.request({
				            	            url: './WorkflowServlet',
				            	            success: function(response){
				            	              workflow.study.getStudies();
				            	              workflow.successHandlingAjax(response);
				            	            },
				            	            failure: function(response) {
				            	              workflow.LoadMask.hide();
				            	            },
				            	            params: { requestType: 'deleteStudy', studyId: studyId }
				            	          });
				            	        }
				            	    });
			                	}
			                })
			                ]
			            });
		        		treeMenu.showAt(e.getXY());
			        }
		        }
			}));
		}

		rootNode.appendChild(deactivatedStudies);
	}

	new Ext.tree.TreeSorter(tree, {
	    folderSort: true,
	    dir: "asc"
	});

	if(snpId)
		workflow.selectSnp(snpId);
};

dbClickHandler = function (node, id){
	if(node.attributes.name == 'show') {
		workflow.showSamples(node.id);
	} else if(node.attributes.name == 'snp'){
		workflow.showResults(node, id);
	}

};

workflow.showResults = function (node, snpId){
	workflow.LoadMask.show();
	var centerPanel = Ext.getCmp('center-panel');

	Ext.Ajax.request({
		url: './SNPDataServlet',
		success: function(response){
			var result = Ext.util.JSON.decode(response.responseText).data;
			centerPanel.removeAll();
			centerPanel.add(new workflow.resultTab({result: result}));
			centerPanel.doLayout();
			workflow.LoadMask.hide();
		},
		failure: function(response) {
			workflow.LoadMask.hide();
		},
		params: { requestType: 'getSnp', snpId: snpId }
	});
};
