workflow.study.sampleGrid = function(studyId){
    var ssstore = new Ext.data.Store({
        reader: new Ext.data.JsonReader({
			id: 'id',
			totalProperty:'totalCount',
			root: 'data',
			fields:[{
			    name: 'id',
			    type: 'int'
			}, {
			    name: 'sampleId',
			    type: 'string'
			}]
        }),
        proxy: new Ext.data.HttpProxy({url:'./WorkflowServlet'}),
        baseParams: {"study.id": studyId, requestType: 'getSamplesFromStudy'},
        remoteSort: true
    });

    var grid = new Ext.grid.GridPanel({
        region:'center',
        margins: '5 5 5 5',
        width: '100%',
        height: 100,
        autoHeight: true,
        autoScroll: true,
        loadMask: true,
        stripeRows: true,
        autoExpandColumn: 'sampleId',
        sm: new Ext.grid.RowSelectionModel({singleSelect:true}),
        view: new Ext.grid.GridView({
            formFit: true
        }),
        store: ssstore,
        columns: [{
	            id: 'sampleId',
	            header: myLocale.lbSampleId,
	            dataIndex: 'sampleId',
	            width: 100,
	            sortable: false
	        }
	    ],
        tbar: new Ext.PagingToolbar({
        	height: 57,
            pageSize: 30,
            store: ssstore,
            displayInfo: true,
            displayMsg: myLocale.lbSampleStep,
            emptyMsg: myLocale.lbNoSamples,
            plugins: new Ext.ux.ProgressBarPager()
        })
    });

    ssstore.load({params:{start: 0, limit: 30}});

    return grid;
};
